!!
!! findfe.sub.f
!!
!! principal developer: Dr. Ye Ding
!! modifications to this source code are only permitted with the permission of the copyright holder
!! or the principal developer.
!!
!! Copyright Health Resources Inc. 2007 
!! You may use distribute, and modify, this code under the terms
!! of the SFold license.  A copy of the Sfold license should have
!! been distribute,d with this file.
!!
!!
!!!!! This is the F77 program for computing the free energy
!!!!! of a given structure. The gcg connect file is chosen
!!!!! to be the input file format because we need in this
!!!!! program the sequence and the structure. Both bp and
!!!!! helix formats present only the structure, thus we
!!!!! will still need an additional input file for the seq.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine f77findfe(n, numseq, fbp, h5, h3, hnum, seq,
     &       eall, pardir, pardirlen)

        integer n, i

        integer numseq(n), fbp(n),
     &       h5(n), h3(n), hnum(n),
     &       hindex

        double precision marginp(4),
     &       eall, estack, eext, ehp, ebg, eint, emloop

        character*1 seq(n)
!        character*80 a(300), b

        integer pardirlen
        character*(*) pardir

        double precision es(4, 4, 4, 4),
     &       ed5(4,4,4), ed5final(4,4,4), ed3(4,4,4),
     &       ehs(4, 4, 4, 4), eis(4, 4, 4, 4),
     &       e21s(4,4,4,4,4,4,4),  e21d(4,4,4,4,4,4,4),
     &       ei22a(4,4,4,4,4,4,4), ei22c(4,4,4,4,4,4,4),
     &       ei22g(4,4,4,4,4,4,4), ei22u(4,4,4,4,4,4,4),
     &       ei11(4,4,4,4,4,4),
     &       eh3(4,4,4,4,4), eh4(4,4,4,4,4,4),
     &       eh(30), eb(30), ei(30)

        double precision  eh3ex(4,4,4,4,4), eh4ex(4,4,4,4,4,4),
     &        esex(4, 4, 4, 4), ed3ex(4,4,4), ed5ex(4,4,4),
     &       ehsex(4, 4, 4, 4), eisex(4, 4, 4, 4),
     &       ehex(30), ebex(30), eiex(30),
     &        ei11ex(4,4,4,4,4,4),
     &       ei22aex(4,4,4,4,4,4,4), ei22cex(4,4,4,4,4,4,4),
     &       ei22gex(4,4,4,4,4,4,4), ei22uex(4,4,4,4,4,4,4),
     &       e21sex(4,4,4,4,4,4,4),  e21dex(4,4,4,4,4,4,4),
     &       aex, bex, cex, slopeex,
     &       tphbex, hguex, h3cex, haex, hbex, iasyex, ex3

        common /stack/ es /dangle/ ed3, ed5, ed5final /HBI/ eh, eb, ei
     &       /Hstack/ ehs /Istack/ eis /int11/ ei11
     &       /int21/ e21s, e21d/ int22
     &       / ei22a,  ei22c, ei22g, ei22u
     &       /tetra/ eh4 / tri /eh3

        common /stackex/ esex /dangleex/ ed3ex, ed5ex
     &       /HBIex/ ehex, ebex, eiex
     &       /Hstackex/ ehsex /Istackex/ eisex /int11ex/ ei11ex
     &       /int21ex/ e21sex, e21dex/ int22ex
     &       / ei22aex,  ei22cex, ei22gex, ei22uex
     &       /tetraex/ eh4ex / triex /eh3ex
     &       /other/aex, bex, cex, slopeex,
     &       tphbex, hguex, h3cex, haex, hbex, iasyex, ex3

        external mpnum, data, energy

!        print *, pardir(1:pardirlen)

        do i=1, n
          if(seq(i) .eq. 'T' .or. seq(i) .eq. 't'
     & .or. seq(i) .eq. 'U' .or. seq(i) .eq. 'u' ) then
          seq(i)='U'
          endif

!    2004/12/20 (Clarence):
!       Replace 'N' by 'A' and its complement by 'T'. See
!       additional notes in ../notes/ directory for the reason
!       in choosing A to replace N.
!
          if (seq(i) .eq. 'A' .or. seq(i) .eq. 'a'
     & .or. seq(i) .eq. 'N' .or. seq(i) .eq. 'n') then
          seq(i) ='A'
          end if

          if (seq(i) .eq. 'C' .or. seq(i) .eq. 'c') then
            seq(i)='C'
          end if

          if (seq(i) .eq. 'G' .or. seq(i) .eq. 'g') then
            seq(i)='G'
          end if
        end do

!        print first 10 and last 10 nt and see input data if n >=10;
!               print thr wholes sequence if n < 10

!        write(0, *) ""
!        if (n .ge. 10) then

!        do i=1, 10
!          write(0, *)  i, seq(i)
!        end do
!        do i=n-9, n
!           write(0, *) i, seq(i)
!        end do

!        else
!        do i=1, n
!          write(0, *)  i, seq(i)
!        end do

!        end if

        call mpnum(seq, n, marginp, numseq)
!
!-- Ivan Auger - 2/25/10 - do not call data if "pardirlen" is 0 or less
        if (pardirlen .gt. 0) then
          call data(pardir, pardirlen)
        end if

!        structure in Zuker structure input format and total free energy
!      reset initial values
        hindex=0
        do i=1, n
          h5(i)=0
          h3(i)=0
          hnum(i)=0
        end do

        do i=1, n

!    3 cases, fbp(i)> i, < i or =0 (neq 0 in first 2 cases)
!    for the helix with i > fbp(i)  it is a redundant copy

          if (i .gt. fbp(i) .or. fbp(i) .eq. 0) then
            go to 99
          end if
!          new helix for i=1
          if (i .eq. 1 .and. fbp(i) .ne. 0) then
            hindex=1
            h5(1)=1
            h3(1)=fbp(1)
            hnum(1)=1
            go to 99
          end if

!          new helix for any i

          if (i .ge. 2) then

            if (fbp(i-1) .eq. 0 .and. fbp(i) .ne. 0) then
              hindex=hindex+1
              h5(hindex)=i
              h3(hindex)=fbp(i)
              hnum(hindex)=1
              go to 99
            end if

!    can be continuing helix or a new helix if fbp(i-1) is the end
!    of a "reduntant" helix or it is a bulge
            if (fbp(i-1) .ne. 0 .and. fbp(i) .ne. 0) then
              if ((i-1) .lt. fbp(i-1) .and.
     &          (fbp(i-1) .eq. (fbp(i)+1))) then
                hnum(hindex)=hnum(hindex)+1
              else
                hindex=hindex+1
                h5(hindex)=i
                h3(hindex)=fbp(i)
                hnum(hindex)=1
              end if
            end if
          end if

 99       continue

        end do

!      compute free energy of the sampled structure
!      if the structure is open, the energy is zero
!      test for empty added 7/20/2011 (war)
        if (hindex .gt.0) then
            call energy(n,   numseq, h5, h3, hnum,
     &          eall, estack, eext, ehp, ebg, eint, emloop, .TRUE.)
        else
            eall = 0.0;
        endif

!       2010-02-15 (Adam) Perform some operation on eall. print eall or divide
!          eall by 1. This tells the f90 -fast compiler that we are indeed
!          interested in this variable, don't optimize it away.
!          I dare you to remove it.
        eall = eall / 1.0
!  fe(isample)=eall

!        write(0, *) ""
!!        write(0, *) "Sequence file = ", infile
!        write(0, 4) "Sequence length = ", n
!        write(0, 5) "Free energy     = ", eall
!        write(0, *) ""

!4  format(A, i9)
!5  format(A, f9.2)

        return
!  stop
      end

      include 'mpnum.f'
      include 'data.f'
      include 'energy.f'
