!!
!! main.f
!!
!! contains original main function.  Now data structures built in sfold.c and main is there
!!
!! principal developer: Dr. Ye Ding
!! modifications to this source code are only permitted with the permission of the copyright holder
!! or the principal developer.
!!
!! Copyright Health Resources Inc. 2007 
!! You may use distribute, and modify, this code under the terms
!! of the SFold license.  A copy of the Sfold license should have
!! been distribute,d with this file.
!!
!!
!    compaq version,use 4 7D arrays ei22a,ei22ac,ei22ag,ei22aU
!!    Rescale version,u0**n is the estimate of the U(1,n),or exact value
!!    use Mersenne T u(0,1) for discrete sampling.
!!            pscale(i)=u0**i,mfe,min.free E from mfold
!!!!! This is the F77 program for computating sampling probabilities of
!!!!!  single stranded bases and seq of witdh 2-4 for "known"  structure
!!!!!! this is a modification of srna.f for most-up-to-date Turner data
!!!!!! it also return complete prob  profile data as in srna.f
!!!!!  about iseed
!   initial seed for u(0,1) sampling,must be done only once in main program,
!    once inital seed set,followings seqs are random,thus
!    initalize seed more than once does not guranteenot randomness,
!    in fact,using unix time,reseed within 1 second gives same result
!!!!!! about (n,n) arrays:
!        u,u1,up are must have; s1,s2,s3 are needed to reducde
!        order of PF from o(n4) to o(n3);
!        upisum and upmsum is the part of up for internal loop and
!        m-loop,it costs nothing to compute in PF step,and used
!        for sampling loop types. If not stored,it takes ~(n2) to
!        compute and the sampling step can be very slow (o(n3)?)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!    2006/10/13 (Clarence):
!       Added new variables,outdir and pardir,to store
!    locations of the output and parameter directories
!    respectively. This allows the Sfold binary to be
!      called in a more flexible way instead of restricting
!    it to be run within the bin subdirectory. All
!    occurrences of '../output/filename' have been
!    replaced by (outdir(1:outdirlen) // '/filename').
!    outdir,pardir,outdirlen,pardirlen are passed
!    into here from the C main program. All files
!    containing subroutines that used ../output/ or
! ../param/ have been updated to take additional
!    parameters of outdir/pardir (including pprob.f,
!    sirna.f,soligo.f and data.f).
      integer n,nr,isample,nsample,ww,iseed,array(3),getpid
      integer i,j,k
      integer counter,w,noligo,wi,nsirna
      integer verbose
      integer ext_mods
!
!    2004/12/20 (Clarence):
!       add new variable for storing width of local folding.
!    default value should be the sequence length-1 so that
!    no constraints are put in the folding unless
!    explicitly specified by user. Default value is set
!    later in the code after n is defined and initialized.c
      integer lflen
!
      parameter(n=76)
      parameter(nsample=1000,ww=4)
      parameter(w=20,noligo=n-w+1)
      parameter(wi=21,nsirna=n-wi+1)
!     parameter(naan19=n-21+1)
      parameter(nr=1)
!
      integer numseq(n),
     &        sn,en,ind,seq0(2),seq1(n,2),bp(2),single(n),
     &        ltype(n),lcount(5,n),hm(n),lm(n),
     &        ss(n,3),iss,fbp(n),ir6(nr),
     &        sbase(n),sseq(ww,n),h5(n),h3(n),hnum(n),
     &        hindex,pnum(101),rightpt(21),
     &        fbp10(10,n),id10(10)
!
      double precision aex,bex,cex,eall,ebg,eext,ehp,eint,emloop,estack,
     &        ex3,h3cex,haex,hbex,hguex,iasyex,maxfe,mfe,minfe,scale,
     &        slopeex,tphbex,u0,
     &        Bprob(nsample),fe(nsample),
     &         lsumpr(n), probm2(n),probmbl(n),
     &        probmbr(n), psbase(n), pscale(n),
     &        probm1(3*n),probmm(3*n),
     &        psseq(ww,n),loopr(5,n),
     &        s1(n,n),s2(n,n),s3(n,n),up(n,n),
     &        u1(n+1,n+1),u(n+1,n+1),
     &        marginp(4),Bprob10(10),fe10(10),groupr(10),probint(21),
     &        eb(30),ebex(30),eh(30),ehex(30),ei(30),eiex(30),
     &        probp(101),feint(10,2),
     &            ed3(4,4,4),  ed3ex(4,4,4),
     &            ed5(4,4,4), ed5final(4,4,4), ed5ex(4,4,4),
     &            eis(4,4,4,4),  eisex(4,4,4,4),
     &             es(4,4,4,4),   esex(4,4,4,4),
     &            ehs(4,4,4,4),  ehsex(4,4,4,4),
     &            eh3(4,4,4,4,4),  eh3ex(4,4,4,4,4),
     &            eh4(4,4,4,4,4,4),  eh4ex(4,4,4,4,4,4),
     &           ei11(4,4,4,4,4,4), ei11ex(4,4,4,4,4,4),
     &           e21d(4,4,4,4,4,4,4), e21dex(4,4,4,4,4,4,4),
     &           e21s(4,4,4,4,4,4,4), e21sex(4,4,4,4,4,4,4),
     &          ei22a(4,4,4,4,4,4,4),ei22aex(4,4,4,4,4,4,4),
     &          ei22c(4,4,4,4,4,4,4),ei22cex(4,4,4,4,4,4,4),
     &          ei22g(4,4,4,4,4,4,4),ei22gex(4,4,4,4,4,4,4),
     &          ei22u(4,4,4,4,4,4,4),ei22uex(4,4,4,4,4,4,4),
     &        ensembleen, einit

      real*4 dtime,delta,tarray(2),tpf,tsamp,ttotal,tout
      character*1 seq(n),seqc(n),seqcopy(n),seqcopyc(n),complement
!     character*80 a(300),b
      integer iostat
      character onechar
!
!    2006/11/16 (Clarence): updated the way to pass filename to open().
!    both intel compiler and sun compiler take formats like
!      open(unit=2,file=(outdir(1:outdirlen) // '/sample.out'),but
!    gcc would fail for the filename part with the concatenation.
!    So we need to assign the filename to a variable first,then
!    pass it along to open(). bufstr would be the temp variable for
!    storing filename and buflen is its max length. We assume the
!    max. filename length is maxfnlen below.
      integer buflen,maxfnlen
      parameter(buflen=1000)
      parameter(maxfnlen=200)
      character*(buflen) bufstr
!
!    2006/10/17 (Clarence): updated the Mersenne Twister to its latest
!       version (2002/1/26) with improved initialization.
!
      external mpnum,partf,data,sample,init_genrand,
     &         energy,pprob,soligo,ssirna,dtime
!
      common /stack/ es
     &       /stackex/ esex
     &       /dangle/ ed3, ed5, ed5final
     &       /dangleex/ ed3ex,ed5ex
     &       /HBI/ eh,eb,ei
     &       /HBIex/ ehex,ebex,eiex
     &       /Hstack/ ehs
     &       /Hstackex/ ehsex
     &       /Istack/ eis
     &       /Istackex/ eisex
     &       /int11/ ei11
     &       /int11ex/ ei11ex
     &       /int21/ e21s,e21d
     &       /int21ex/ e21sex,e21dex
     &       /int22/ ei22a,ei22c,ei22g,ei22u
     &       /int22ex/ ei22aex,ei22cex,ei22gex,ei22uex
     &       /tetra/ eh4
     &       /tetraex/ eh4ex
     &       /tri/ eh3
     &       /triex/ eh3ex
     &       /other/ aex,bex,cex,slopeex,tphbex,hguex,h3cex,haex,hbex,
     &               iasyex,ex3
!
!    2006/11/16 (Clarence): error checking on buflen to make sure
!    neither outdirlen+maxfnlen nor pardirlen+maxfnlen would
!    be greater than the buflen defined above.c
      if (outdirlen+maxfnlen .gt. buflen) then
        write(0,*) " Error: length of output directory too long"
        go to 900
      end if

      if (pardirlen+maxfnlen .gt. buflen) then
        write(0,*) " Error: length of parameter directory too long"
        go to 900
      end if
!
      lflen=n-1
      tout=0.0
      delta=dtime(tarray)
!
!    for DNA seq w/complement,complement=T (eg. lacZ,lacZY),otherwise=F
      complement='F'
!     complement='T'
!
!    give exact (roundoff,15 digits precision)
!    or estimate (via mfe) u0 suggested by Viena,u0=1 for no scale
!
      scale=1000.d0/(1.9872d0*310.15d0)
      mfe=-28.9d0
!     u0=dexp(-1.04*mfe*scale/dble(n))
!     u0=1.d0
!            Ye'empirical range: (1.652  1.86  1.928   1.972 2.224)
      u0=1.928d0
!     u0=1.7d0
!     u0=2.1d0
!     u0=2.2d0
!            for exact or other est.
!     u0=1.9427916049598d0
!
!!!!! set initials for sbase and sseq. IMPORTANT!
      do i=1,n
        sbase(i)=0
      end do
!
      do i=1,ww
        do j=1,n
          sseq(i,j)=0
        end do
      end do
!
!                        compute scales for PF
      pscale(1)=1.d0/u0
      do i=2,n
        pscale(i)=pscale(i-1)/u0
      end do
!
!    2005/02/01 (Clarence):
!    in order to be safe,we initialize all other big arrays here
      do i=1,n+1
        do j=1,n+1
          u(i,j)=0.d0
          u1(i,j)=0.d0
        end do
      end do
!
      do i=1,n
        do j=1,n
          up(i,j)=0.d0
          s1(i,j)=0.d0
          s2(i,j)=0.d0
          s3(i,j)=0.d0
        end do
      end do
!
!      set "random" seed:100000+total seconds for hour & minutes
!    2004/12/20 (Clarence):
!    iseed can now be set as an option at the Sfold command line. iseed
!    is then passed to this subroutine in the dynamic version as a
!    parameter. Here what we are doing is in case the user does not
!    set a random seed,iseed will have a default value of 0 and,in
!    that case,we will set it according to the system time as below.
      if (iseed .eq. 0) then
!         from last midnight and seconds* process ID
        call itime(array)
        iseed=10000+array(1)*3600+array(2)*60+array(3)*getpid()
!
!      below iseed will contain the number of seconds elapsed from Jan 1,1970.
!         The current value is around 1044472214 seconds ~=33 years.
!      iseed=time()
      end if
!
!    2006/10/17 (Clarence): updated the Mersenne Twister to its latest
!       version (2002/1/26) with improved initialization.
!
      call init_genrand(iseed)
!
!!!Note: if unit 11-20 are needed,they must be after call data (),which
!!        uses unit 11-20 then close them!!!
!
      open(unit=1,file='../data/tRNAala.dat',status='old',
     & access='direct',form='formatted',recl=1)
!
      bufstr=outdir(1:outdirlen) // '/sample.out'
      open(unit=2,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/bp.out'
      open(unit=3,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/10structure.out'
      open(unit=4,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/sstrand.out'
      open(unit=5,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/10structure_2.out'
      open(unit=6,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/fe.out'
      open(unit=10,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/fe_init.out'
      open(unit=25,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/cdf.out'
      open(unit=9,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/pdf.out'
      open(unit=8,file=bufstr(1:len_trim(bufstr)),status='replace')
!
      bufstr=outdir(1:outdirlen) // '/loopr.out'
      open(unit=7,file=bufstr(1:len_trim(bufstr)),status='replace')
!
!            input data in Fasta form,
!        comment line+multiple lines,permit line #,space in Genbank
!        limits set by b and a(300): 80 per line,300 lines
!
!          read(1,5) b
!
!       do i=1,300
!      counter=i
!      read(1,5,end=10) a(i)
!
!       end do
!
!5    format(A80)
!
!10    continue
!
!     index=0
!      do i=1,counter
!         do 15 j=1,80
!
!           if (a(i)(j:j) .eq. ' ' .or. ichar(a(i)(j:j)) .eq. 0
!     & .or. lge('9',a(i)(j:j)) ) then
!                 go to 15
!              else
!                  index=index+1
!                  seq(index)=a(i)(j:j)
!                  end if
!
!15        continue
!
!       end do
!
!      do i=1,n
!        if (seq(i) .eq. 'T' .or. seq(i) .eq. 't'
!     & .or. seq(i) .eq. 'U' .or. seq(i) .eq. 'u' ) then
!        seq(i)='U'
!        seqc(i)='A'
!        end if
!
!        if (seq(i) .eq. 'A' .or. seq(i) .eq. 'a') then
!         seq(i)='A'
!         seqc(i)='T'
!          end if
!
!        if (seq(i) .eq. 'C' .or. seq(i) .eq. 'c') then
!         seq(i)='C'
!         seqc(i)='G'
!          end if
!
!        if (seq(i) .eq. 'G' .or. seq(i) .eq. 'g') then
!         seq(i)='G'
!         seqc(i)='C'
!          end if
!      end do
!
5     format(A80)
!
!    2006/11/17 (Clarence):
!    Remove the whole section below for reading in sequence data. The
!    following codes work fine under intel compiler and SUN compiler,
!    but fail under GNU g77 since it cannot correctly parse and skip
!    the header line,thus getting incorrect sequence data. So I
!    decided to leave the job of reading sequence file to the main
!    C program that calls this fortran subroutine,which means we
!      do not need to do anything with the sequence file now. I just
!      do a simple check below to ensure sequence data looks right.
      do i=1,n
        if (seq(i) .ne. 'A' .and. seq(i) .ne. 'U' .and.
     &     seq(i) .ne. 'C' .and. seq(i) .ne. 'G' .and.
     &     seq(i) .ne. 'N') then
          write(0,*) " Error: invalid sequence data"
          go to 900
        end if
      end do
!
!    2004/12/20 (Clarence):
!    replaced the whole segment of code in reading the FASTA formatted
!    file since the original version had the 80 characters per line
!    limitation. if the input file has lines longer than 80 char,then
!    the old version will not be able to read in the sequence correctly.
!    this newer one solves the problem by reading the sequence data
!    one character at a time,using the ADVANCE='NO' parameter in read()
!
!
!!       start reading in the header line one character at a time
!!       until the end of line is reached
!    iostat=0
!    i=1
!
!!       iostat=-1 means EOF
!          do while (iostat .eq. 0)
!!         read one character
!
!!    unfortunately the advance option is not supported under g77!
!!    so we need to find another workaround.... the current
!!    solution is to open the file for direct-access with records
!!    of 1 character
!!          read(1,'(A1)',IOSTAT=iostat,ADVANCE='NO') onechar
!
!      read(1,'(A1)',IOSTAT=iostat,rec=i) onechar
!      i=i+1
!
!!            if (ichar(onechar) .eq. 32 .and. iostat .lt. -1 ) then
!            if (ichar(onechar) .eq. 10) then
!!           a newline character has been read
!            go to 10
!              end if
!          end do
!
10    continue
!
!!       start reading in the sequence data
!    iostat=0
!    index=0
!
!!       iostat=-1 means EOF
!          do while (iostat .eq. 0)
!!         read one character
!!          read(1,'(A1)',IOSTAT=iostat,ADVANCE='NO') onechar
!
!      read(1,'(A1)',IOSTAT=iostat,rec=i) onechar
!      i=i+1
!
!        if (onechar .eq. 'T' .or. onechar .eq. 't'
!     & .or. onechar .eq. 'U' .or. onechar .eq. 'u' ) then
!        index=index+1
!        seq(index)='U'
!        seqc(index)='A'
!        end if
!
!        if (onechar .eq. 'A' .or. onechar .eq. 'a') then
!        index=index+1
!        seq(index)='A'
!        seqc(index)='T'
!          end if
!
!        if (onechar .eq. 'C' .or. onechar .eq. 'c') then
!        index=index+1
!        seq(index)='C'
!        seqc(index)='G'
!          end if
!
!        if (onechar .eq. 'G' .or. onechar .eq. 'g') then
!        index=index+1
!        seq(index)='G'
!        seqc(index)='C'
!          end if
!
!    2004/12/20 (Clarence):
!    the undetermined base 'N' is added into the allowable
!    list. We will first set it to N here temporarily,and
!    then after doing the reverse-complement (if needed),
!    we will replace N by A and its complement by T. See
!    additional notes in ../notes/ directory for the reason
!    in choosing A to replace N.
!
!        if (onechar .eq. 'N' .or. onechar .eq. 'n') then
!        index=index+1
!        seq(index)='N'
!        seqc(index)='N'
!          end if
!
!        if (index .eq. n) then
!        go to 15
!          end if
!
!          end do
!
15    continue
!
!                  if complement DNA seq from Genbank
!                  do (1) reverse the seq (2) take complement
!                for non-complement,take the seq at the mRNA
      if (complement .eq. 'T' ) then
        do i=1,n
          seqcopy(i)=seq(i)
        end do
!
        do i=1,n
          seq(i)=seqc(n-i+1)
        end do
!
        do i=1,n
          seqc(i)=seqcopy(n-i+1)
          if (seqc(i) .eq. 'U') then
            seqc(i)='T'
          end if
          if (seq(i) .eq. 'T') then
            seq(i)='U'
          end if
        end do
      else
        continue
      end if
!
!    2004/12/20 (Clarence):
!    here we first save a copy of the original sequence
!    into seqcopy(),and then we replace all occurrences
!    of 'N' in seq() with 'A'. By this,all functions
!    will work on the replaced sequence seq() and only
!    use seqcopy() for output to text files. Next,we
!    will need to force this updated base to be open
!    as we don't really want 'N' to pair with anyone.
!    AGAIN: PLEASE USE seqcopy() and seqcopyc() for
!    sequence printout from now on.
      do i=1,n
        seqcopy(i)=seq(i)
        if (seq(i) .eq. 'N') then
          seq(i)='A'
          seqc(i)='T'
          seqcopyc(i)='N'
          do j=max(i-lflen,1),i-4
            up(j,i)=-999.d0
          end do
          do j=i+4,min(i+lflen,n)
            up(i,j)=-999.d0
          end do
        else
          seqcopyc(i)=seqc(i)
        end if
      end do
!
!    2004/09/21 (Clarence):
!    go through the whole sequence in a double loop,
!    locate all non-canonical bps and mark the up(i,j)
!    value for that entry to be -999.d0,where j>=i+4.
!    for j<=i+3,up(i,j) is not set and should remain 0.
!
!    2004/12/20 (Clarence):
!    updated to take into consideration the local folding
!    length when setting the special value -999.d0. The
!    idea is simply that the only-canonical bp constraint
!    is set only for bases within the allowable range in
!    local folding. We don't initialize non-canonical bps
!    entries to -999.d0 if they are outside the range
!    specified by lflen and those will then remain 0.
!    this is possible because the partition function will
!    not consider these out-of-range entries anyway.
      do i=1,n
!        do j=i+4,n
        do j=i+4,min(i+lflen,n)
          if ((seq(i) .eq. 'A' .and. seq(j) .eq. 'U') .or.
     &       (seq(i) .eq. 'U' .and. seq(j) .eq. 'A') .or.
     &       (seq(i) .eq. 'G' .and. seq(j) .eq. 'C') .or.
     &       (seq(i) .eq. 'C' .and. seq(j) .eq. 'G') .or.
     &       (seq(i) .eq. 'G' .and. seq(j) .eq. 'U') .or.
     &       (seq(i) .eq. 'U' .and. seq(j) .eq. 'G')) then
            continue
          else
            up(i,j)=-999.d0
          end if
        end do
      end do
!
!    2004/12/20 (Clarence):
!    the following section is better to be included as well
!    for cases where lflen is set to less than 4. ideally
!    when the user sets lflen<4,we should return only
!    unfolded structures. if the following special case
!    is not handled,up(i,i+4) will be zero before calling
!    partf(). when the partf is run,up(i,i+4) will be
!    initialized to a small number (ehex(3)*pscale(5))
!    instead of zero as it's not the special
!    value of -999d.0. everything after that will be wrong
!    and some impossible pairs will be sampled due to that
!    small number!
      if (lflen < 4) then
        do i=1,n-4
          up(i,i+4)=-999.d0
        end do
      end if
!
!    2004/12/20 (Clarence):
!    additional constraints are to be set here. constraint
!    file is read and then the specified entry will be set
!    to the special value of -999.d0. a lot of error
!    checkings need to be done on the input constraints
      if (conflen .gt. 0) then
        open(unit=24,file=confname(1:conflen),status='old')
!
        iostat=0
        do while(iostat .ne. -1)
          onechar=' '
          i=-1
          j=-1
          k=-1
          read(24,*,IOSTAT=iostat) onechar,i,j,k
!
!    let's do some error checking here....
!
!    we are not supporting 'F' for now,so comment out.
!    use the following line when 'F' is implemented
!          if (onechar .ne. 'F' .and. onechar .ne. 'P') then
          if (onechar .ne. 'P') then
            go to 16
          end if
!
          if (i .le. 0 .or. j .lt. 0 .or. k .le. 0 .or. i .gt. n
     & .or. j .gt. n) then
            go to 16
          end if
!
          if (j .gt. 0 .and. j-i .lt. 4) then
            go to 16
          end if
!
          if (i+k-1 .gt. n) then
            go to 16
          end if
!
          if (j .gt. 0 .and. j-k+1 .le. 0) then
            go to 16
          end if
!
!    i,j,k defines a helix,then k can only be
!    smaller than or equal to (j-i+1)/2
          if (j .gt. 0 .and. k .gt. (j-i+1)/2) then
            go to 16
          end if
!
!    no need to take care of the condition related to
!    lflen here,as we are putting a check on
!    j-i <=lflen a few lines below when we try to
!    assign the special value
!
!          if (j .gt. 0 .and. j-i .gt. lflen) then
!          go to 16
!            end if
!
!    error checking done finally...
!    now set the appropriate entries
!
          if (j .gt. 0) then
!    only preventing a particular helix (i,j),(i+1,j-1),
!    (i+2,j-2)...(i+k-1,j-k+1) here.
!
!    also need to take care of the lflen here:
!      do nothing if (j-counter)-(i+counter) > lflen
            do counter=0,k-1
              if (j-counter-i-counter .le. lflen) then
                up(i+counter,j-counter)=-999.d0
              end if
            end do
          else
!
!    we are making the fragment of bases
!    from i to (i+k-1) to be open here.
!    j is 0 under this else case,so i am
!    reusing it to be the loop counter
            do counter=i,i+k-1
              do j=max(counter-lflen,1),counter-4
                up(j,counter)=-999.d0
              end do
              do j=counter+4,min(counter+lflen,n)
                up(counter,j)=-999.d0
              end do
            end do
          end if
!
16        continue
!
        end do
        close(24)
      end if
!
!    2004/12/20 (Clarence):
!    this part is for the initialization of local
!    folding. based on the width set by lflen,
!    we set all possible up(i,j) to the special
!    value -999.d0 if the pairing is longer than
!    the allowable range,i.e. if j-i > lflen.
!
!          do i=1,n
!            do j=i+lflen+1,n
!            up(i,j)=0.d0
!            end do
!          end do
!
!     print first 10 and last 10 nt and see input data if n >=10;
!        print thr wholes sequence if n < 10
      if (n .ge. 10) then
        do i=1,10
          write(0,*) i,seqcopy(i)
        end do
        do i=n-9,n
          write(0,*) i,seqcopy(i)
        end do
      else
        do i=1,n
          write(0,*) i,seqcopy(i)
        end do
      end if
!
!                    input known structure data
!                deleted,see ~/srna/single_NAR01.f
      call mpnum(seq,n,marginp,numseq)
      call data(pardir,pardirlen)
!
      bufstr=outdir(1:outdirlen) // '/sample_1000.out'
      open(unit=12,file=bufstr(1:len_trim(bufstr)),status='replace')
!
!    see dtime http://www.compaq.com/fortran/docs/unix-um/3f/etime.3f.html
      delta=dtime(tarray)
      tout=tout+delta
!
      write(0,*) ""
      write(0,*) "Random seed = ",iseed
!      write(0,*) "Sequence file = ",infile
      write(0,*) "Sequence length n = ",n
      write(0,*) "Number of structures in a sample = ",nsample
      write(0,*) "Reverse complement = ",complement
      write(0,*) "Length of antisense oligo = ",w
      write(0,*) "Maximum distance between paired bases = ",lflen
!
      if (conflen .gt. 0) then
        write(0,*) "Additional constraint file = ",confname(1:conflen)
      else
        write(0,*) "Additional constraint file = none"
      end if
!
      write(0,*) ""
!
      call partf(n,numseq,pscale,u,up,u1,s1,s2,s3,lflen)
!
!    2004/09/23 (Clarence):
!       this is for debugging purpose... remove in final release
!          do i=1,n
!            do j=i,n
!              if (up(i,j) .gt. 0) then
!                write(0,*) "up > 0 at ",i,",",j,": ",up(i,j)
!                end if
!            end do
!          end do
!
      delta=dtime(tarray)
      tpf=delta
!
      write(0,*) "U0 = ",u0
      write(0,*) "scaled U(1,n) = ",u(1,n)
!     2010-11-12 (Adam): write ensemble energy to stdout and header of fe_init.out
      ensembleen=-0.6163301d0*( dlog(u(1,n)) + dble(n)*dlog(u0) )
      write(0,*) "-RT ln(U(1,n))=", ensembleen
      write(25,*) "Ensemble free energy (based on initial energies):",
     &  "-RT ln(U)=", ensembleen
      write(25,*) "(U is the partition function for the sequence, see Ding and Lawrence 2003)"
      write(0,*) ""
      write(0,*) "Time for PFs = ",tpf
!
!       to output all the necessary values into a file for
!       calculating the Boltzmann probability
      bufstr=outdir(1:outdirlen) // '/bprob.out'
      open(unit=23,file=bufstr(1:len_trim(bufstr)),status='replace')
      write(23,123) scale
      write(23,123) u(1,n)
      write(23,*) n
      write(23,123) u0
      close(23)
!
123     format(e25.20,"L")
!
!      write(0,*) "up(1,n)",up(1,n)
!
!         do i=1,n
!         write(0,*) "i = ",i,"u(1,i)",u(1,i)
!         end do
!
!                set initials for lcount
      do i=1,n
        do j=1,5
          lcount(j,i)=0
        end do
      end do
!
      tsamp=0.0
      delta=dtime(tarray)
      tout=tout+delta
!
!                now generate nsample structures
      do 100 isample=1,nsample
!      write(0,*) "# of sample:",isample
!                reset initial values for SS (upper tri.) & fbp!!
        do i=1,n
          fbp(i)=0
          do j=1,3
            ss(i,j)=0
          end do
        end do
!                start with ss(1,*)=(1,n,0),iss=1
        ss(1,1)=1
        ss(1,2)=n
        ss(1,3)=0
        iss=1
30      continue
!                output for short sequence w/o sampling
        if (iss .eq. 0) then
          go to 300
        end if
!
        if ((ss(iss,2)-ss(iss,1)) .lt. 4) then
!        must be external loop (dangling or 2 domain junction)
!        see seq0 of sample.f,seq0 only in case
!        with unknow pairing end. In fact,ss(iss,3)=1 impossible here.
          if (ss(iss,3) .eq. 0) then
            do i=ss(iss,1),ss(iss,2)
              lcount(5,i)=lcount(5,i)+1
            end do
          end if
!
          if (iss .eq. 1) then
            go to 300
          end if
!
          if (iss .gt. 1) then
            iss=iss-1
            go to 30
          end if
        end if
!            en-sn<6 with BP sn.en,can't have more BP(for stack)
!
        if ((ss(iss,2)-ss(iss,1)) .lt. 6 .and. ss(iss,3) .eq. 1 ) then
          fbp(ss(iss,2))=ss(iss,1)
          fbp(ss(iss,1))=ss(iss,2)
!
!                        output for hairpin-loop
          do i=ss(iss,1)+1,ss(iss,2)-1
            lcount(1,i)=lcount(1,i)+1
          end do
!
          if (iss .eq. 1) then
            go to 300
          end if
!
          if (iss .gt. 1) then
            iss=iss-1
            go to 30
          end if
        end if
!
!                        now sample
        sn=ss(iss,1)
        en=ss(iss,2)
        ind=ss(iss,3)
!
!            write(0,*) sn,en,ind
!
        call sample(n,numseq,sn,en,ind,pscale, u,up,u1,s1,s2,s3,ir6,
     & hm,lm,probmbr,probmbl,probm1,probm2,probmm,seq0,seq1,bp,single,
     & ltype)
!
        if (bp(1) .ne. 0) then
          fbp(bp(1))=bp(2)
          fbp(bp(2))=bp(1)
        end if
!
        do i=1,n
          if (ltype(i) .ne. 0) then
            lcount(ltype(i),i)=lcount(ltype(i),i)+1
          end if
        end do
!
!      if whole fragment is open,then move to next fragment in the stack
!        end if there is no more fragment
!    no need to evaluate fbp(i) because they are initialized to 0
        do i=sn,en
          if (single(i) .ne. 1) then
            go to 39
          end if
        end do
!
!      write(0,*) "whole fragment open: ",sn,en,iss
!
        if (iss .gt. 1) then
          iss=iss-1
          go to 30
        end if
!
        if (iss .eq. 1) then
          go to 300
        end if
!
39      continue
!
!
!            special case: sampling stops for H-loop with iss=1,
!                      for no new sequences returned
        if (iss .eq. 1 .and. ind .eq. 1 .and. ir6(1) .eq. 1) then
          go to 300
        end if
!
!        for all other cases,update iss,ss with new sub sequences
        iss=iss-1
        if (seq0(1) .ne. 0) then
          iss=iss+1
          ss(iss,1)=seq0(1)
          ss(iss,2)=seq0(2)
          ss(iss,3)=0
        end if
!
        do i=1,n
          if (seq1(i,1) .ne. 0) then
            iss=iss+1
            ss(iss,1)=seq1(i,1)
            ss(iss,2)=seq1(i,2)
            ss(iss,3)=1
          end if
        end do
!
        go to 30
!
300     continue
!
!        now sampling for one structure is complete!
!        produce data  for known tRNA-ala,
!        for for prob of 0 or 1 of single stranded base/subseq (in misc.f)
!
!!        output   to bp.out for 2Dhist of all sampled structures
!!        note that both i-j and j-i are output,to only do a
!!        2dhist on upper left triangle,j >i case is excluded!
!!    (Clarence had a counting script to excluded i > j cases in the past).
!
!!!!!   stop the clock for timing the sampling procedure
!!!!!   cuz we don't want to include the I/O time into it
!
        delta=dtime(tarray)
        tsamp=tsamp+delta
!
        write(3,*) "Structure ",isample
!
        do i=1,n
          if (fbp(i) .ne. 0 .and. (fbp(i) .gt. i) ) then
            write(3,31) i,fbp(i)
          end if
        end do
!
        delta=dtime(tarray)
        tout=tout+delta
!
!                now compute counts of single stranded bases
!                & subsequences (2 <=ww <=4)
        do i=1,n
          if (fbp(i) .eq. 0) then
            sbase(i)=sbase(i)+1
          end if
        end do
!
        do i=2,ww
          do j=1,n-i+1
            do k=j,j+i-1
              if (fbp(k) .ne. 0) then
                go to 25
              end if
            end do
            sseq(i,j)=sseq(i,j)+1
25          continue
          end do
        end do
!
!            structure in Zuker structure input format and total free energy
!            reset initial values
        hindex=0
        do i=1,n
          h5(i)=0
          h3(i)=0
          hnum(i)=0
        end do
!
        do i=1,n
!        3 cases,fbp(i)> i,< i or=0 (neq 0 in first 2 cases)
!        for the helix with i > fbp(i) it is a redundant copy
          if (i .gt. fbp(i) .or. fbp(i) .eq. 0) then
            go to 99
          end if
!                    new helix for i=1
          if (i .eq. 1 .and. fbp(i) .ne. 0) then
            hindex=1
            h5(1)=1
            h3(1)=fbp(1)
            hnum(1)=1
            go to 99
          end if
!                    new helix for any i
          if (i .ge. 2) then
            if (fbp(i-1) .eq. 0 .and. fbp(i) .ne. 0) then
              hindex=hindex+1
              h5(hindex)=i
              h3(hindex)=fbp(i)
              hnum(hindex)=1
              go to 99
            end if
!
!        can be continuing helix or a new helix if fbp(i-1) is the end
!        of a "reduntant" helix or it is a bulge
!
            if (fbp(i-1) .ne. 0 .and. fbp(i) .ne. 0) then
              if ((i-1) .lt. fbp(i-1) .and.
     & (fbp(i-1) .eq. (fbp(i)+1))) then
                hnum(hindex)=hnum(hindex)+1
              else
                hindex=hindex+1
                h5(hindex)=i
                h3(hindex)=fbp(i)
                hnum(hindex)=1
              end if
            end if
          end if
99        continue
        end do
!
!            compute free energy of the sampled structure
!      call energy function only when the sequence is not completely open
        if (hindex .gt. 0) then
          call energy(n, numseq, h5, h3, hnum, eall,
     &                estack, eext, ehp, ebg, eint, emloop, .TRUE.)
          call energy(n, numseq, h5, h3, hnum, einit,
     &                estack, eext, ehp, ebg, eint, emloop, .FALSE.)
        else
          eall=0.d0
          einit=0.d0
        end if
        fe(isample)=eall
!
!            compute the Bolzmann probability of the structure
!            unscaled u(1,n)=scaled u(1,n)*(u0**n),see notes.
!            Need to avoid overflow here by using log!
        Bprob(isample)=
     &    dexp(-scale*einit-(dlog(u(1,n))+dble(n)*dlog(u0)))
!
        delta=dtime(tarray)
        tsamp=tsamp+delta
!
!                output total free energy
        write(10,60) isample,fe(isample)
!    2010-11-12 (Adam) Added difference between eall and einit
        write(25,601) isample, einit, (fe(isample) - einit)
!
!                output structure
        write(2,61) isample,fe(isample),Bprob(isample)
        do i=1,n
          write(2,31) i,fbp(i)
        end do
!
        delta=dtime(tarray)
        tout=tout+delta
!
!            output structures in triplet (none zero) format
        if (isample .eq. 1) then
          write(12,101)
101   format( '(i j k): helix formed by base pairs i-j, (i+1)-(j-1),...,(i+k-1)-(j-k+1)',/ / )
        end if
!
        write(12,61) isample,fe(isample),Bprob(isample)
!
        do i=1,n
          if (h5(i) .ne. 0) then
            write(12,32) h5(i),h3(i),hnum(i)
          end if
        end do
!
100     continue
!
!        to get time for sampling,comment out write(3,31) &
!          write(2,61) within do 100 above,for 589 nt,these
!        outputs take about 10 s and sampling of 1000 take 20 s.
        delta=dtime(tarray)
        tsamp=tsamp+delta
!
        write(0,*) "Time for sampling = ",tsamp
        write(0,*) "Time for PFs & sampling = ",tpf+tsamp
!
        call pprob(n,nsample,u0,u,fe,pnum,probp,rightpt,probint,
     & outdir,outdirlen)
!
        do i=1,101
          write(9,80) pnum(i),probp(i)
        end do
!
        do i=1,21
          write(8,80) rightpt(i),probint(i)
        end do
!
80      format(i5,3x,f10.8)
!
!          compute sampling probabilities of single stranded region
        do i=1,n
          psbase(i)=dble(sbase(i))/dble(nsample)
        end do
!
        do i=2,ww
          do j=1,n-i+1
            psseq(i,j)=dble(sseq(i,j))/dble(nsample)
          end do
        end do
!
!         compute probs a base is in particular type of loop & output
        do i=1,n
          lsumpr(i)=0.d0
          do j=1,5
            loopr(j,i)=dble(lcount(j,i))/dble(nsample)
            lsumpr(i)=lsumpr(i)+loopr(j,i)
          end do
!
!        below has been tested: psbase(i)=lsumpr(i)
!         if (    (psbase(i)-lsumpr(i)) .ge. 0.001d0 ) then
!             write(0,*) i,psbase(i),lsumpr(i)
!           end if
!
          write(7,64) i,seqcopy(i),loopr(1,i),loopr(2,i),
     & loopr(3,i),loopr(4,i),loopr(5,i),lsumpr(i)
        end do
!
!    calculate max,and min fe,10 evrny intervals,mfe for each interval,
!    freq. of each interval,output these and their structures.
!00    This part will be replaced by class representation
        close(2)
        minfe=fe(1)
        maxfe=fe(1)
        do i=2,nsample
          if ( fe(i) .lt. minfe) then
            minfe=fe(i)
          end if
          if ( fe(i) .gt. maxfe) then
            maxfe=fe(i)
          end if
        end do
!
!      write(0,*) minfe,maxfe
!
        do i=1,10
          feint(i,1)=minfe+dble(i-1)*(maxfe-minfe)/10.d0
          feint(i,2)=minfe+dble(i)*(maxfe-minfe)/10.d0
        end do
!        now find mfe for each interval and its structure
!            first setting initials @ upper limit of teh interval
        do i=1,9
          fe10(i)=feint(i,2)
          groupr(i)=0.d0
          id10(i)=0
        end do
!
        fe10(10)=maxfe
        groupr(10)=0.d0
        id10(10)=0
!
        do i=1,nsample
          do j=1,9
            if (fe(i) .ge. feint(j,1) .and. fe(i) .lt. fe10(j)) then
              fe10(j)=fe(i)
              id10(j)=i
              Bprob10(j)=Bprob(i)
            end if
!
            if (fe(i) .ge. feint(j,1)
     & .and. fe(i) .lt. feint(j,2)) then
              groupr(j)=groupr(j)+1.d0/dble(nsample)
            end if
          end do
!                for 10th interval
          if (fe(i) .ge. feint(10,1) .and. fe(i) .le. fe10(10)) then
            fe10(10)=fe(i)
            id10(10)=i
            Bprob10(10)=Bprob(i)
          end if
!
          if (fe(i) .ge. feint(10,1) .and. fe(i) .le. maxfe) then
            groupr(10)=groupr(10)+1.d0/dble(nsample)
          end if
        end do
!
!        reset fe10(k) if no structure for interval k < 10
        do i=1,9
          if (fe10(i) .eq. feint(i,2)) then
            fe10(i)=0.d0
          end if
        end do
!
!        retrieve structure data from sample.out and output
        do i=1,10
          bufstr=outdir(1:outdirlen) // '/sample.out'
          open(unit=2,file=bufstr(1:len_trim(bufstr)),status='old')
          write(4,61) i,fe10(i),Bprob10(i)
          do j=1,(id10(i)-1)*(n+1)
            read(2,5) b
          end do
          read(2,5) b
!        note for interval w/o structure,id10(i)=0,output empty
          if (id10(i) .ne. 0) then
            do j=1,n
              read(2,31) k,fbp10(i,j)
              write(4,50) j,seqcopy(j),j-1,j+1,fbp10(i,j),j
            end do
          end if
!
          if (id10(i) .eq. 0) then
            do j=1,n
              write(4,50) j,seqcopy(j),j-1,j+1,id10(i),j
            end do
          end if
!
          close(2)
        end do
!
!        to replace sample.out by a blank file to save
!        space (7MB for n=589),undo this for future
!        classification,and then delete afterwards
!     Adam added --verbose option 2009-02-19
        if (verbose .eq. 0) then
          bufstr=outdir(1:outdirlen) // '/sample.out'
          open(unit=2,file=bufstr(1:len_trim(bufstr)),
     & status='replace')
          write(2,*) 'Structure data in BP format removed to save
     & disk space. See file sample_1000.out for triplet format.'
          close(2)
        end if
!
!            output group info
        do i=1,9
          write(6,62) feint(i,1),feint(i,2),groupr(i),fe10(i)
        end do
!
        write(6,63) feint(10,1),feint(10,2),groupr(10),fe10(10)
!
!00        replace above by class representation in future
!      do i=1,10
!        write(0,*) id10(i)
!      end do
!
!                output for complete profile
        do i=1,n
          write(5,51) i,seqcopy(i),seqcopyc(i),psbase(i),psseq(2,i),
     & psseq(4,i)
!     & ,psseq(6,i),psseq(8,i),psseq(10,i)
        end do
!
31    format(i5,1x,i5)
32    format(i5,1x,i5,1x,i5)
50    format(i5,1x,a1,4i6)
51    format(i5,1x,2(A1,1x),3(1x,f5.3))
60    format(i4,3x,f8.2)
601   format(i4,3x,f8.2,3x,f8.2)
61    format('Structure',1x,i8,3x,f8.2,3x,e15.5)
611   format('Structure',1x,i8,3x,f8.2,3x,e15.5,3x,i1)
62    format('[',f8.2,',',f8.2,')',1x,f5.3,1x,f8.2)
63    format('[',f8.2,',',f8.2,']',1x,f5.3,1x,f8.2,1x)
64    format(i5,1x,A1,1x,6(1x,f5.3))
!
!            output oligo info if n>=w,otherwise write blank files
        if (n .ge. w) then
          if (ext_mods .eq. 2 .or. ext_mods .eq. 3) then
            call soligo(n,w,noligo,seq,seqc,
     & psbase,psseq,ww,seqcopy,seqcopyc,outdir,outdirlen)
          end if
        else
          bufstr=outdir(1:outdirlen) // '/oligo.out'
          open(unit=20,file=bufstr(1:len_trim(bufstr)),
     & status='replace')
          write(20,*) 'No output because oligo length exceeds length
     & of the target RNA!'
          close(20)
!
          bufstr=outdir(1:outdirlen) // '/oligo_f.out'
          open(unit=20,file=bufstr(1:len_trim(bufstr)),
     & status='replace')
          write(20,*) 'No output because oligo length exceeds length
     & of the target RNA!'
          close(20)
        end if
!
!            output siRNA info if n>=wi,otherwise write blank files
        if (n .ge. wi) then
          if  (ext_mods .eq. 1 .or. ext_mods .eq. 3) then
!
            call ssirna(n,wi,nsirna,seq,seqc,psbase,psseq,ww,ed3,
     &              seqcopy,seqcopyc,outdir,outdirlen)
          end if
        else
          bufstr=outdir(1:outdirlen) // '/filtered.out'
          open(unit=20,file=bufstr(1:len_trim(bufstr)),
     & status='replace')
          write(20,*) 'No output because length of the target RNA is
     & less than 21 nt!'
          close(20)
!
          bufstr=outdir(1:outdirlen) // '/score12.out'
          open(unit=20,file=bufstr(1:len_trim(bufstr)),
     & status='replace')
          write(20,*) 'No output because length of the target RNA is
     & less than 21 nt!'
          close(20)
!
          bufstr=outdir(1:outdirlen) // '/sirna.out'
          open(unit=20,file=bufstr(1:len_trim(bufstr)),
     & status='replace')
          write(20,*) 'No output because length of the target RNA is
     & less than 21 nt!'
          close(20)
!
          bufstr=outdir(1:outdirlen) // '/stability.out'
          open(unit=20,file=bufstr(1:len_trim(bufstr)),
     & status='replace')
          write(20,*) 'No output because length of the target RNA is
     & less than 21 nt!'
          close(20)
!
        end if
!
        close(1)
        close(3)
        close(4)
        close(5)
        close(6)
        close(10)
        close(9)
        close(8)
        close(7)
        close(12)
        close(25)
!
        delta=dtime(tarray)
        tout=tout+delta
        write(0,*) "Time for output & others = ",tout
        ttotal=tpf+tsamp+tout
        write(0,*) "Total cpu time = ",ttotal
!
900     stop
      end
!
      include 'mpnum.f'
      include 'data.f'
      include 'partf.f'
      include 'sample.f'
      include 'discrete.f'
      include 'soligo.f'
      include 'sirna.f'
      include 'energy.f'
      include 'pprob.f'
!    2006/10/17 (Clarence): 'mt19937ar.f' already included in 'discrete.f'
!
