#!/usr/bin/perl

#
# Pre-process fortran code to produce memory saving version
# Usage: fortran_pp.pl fortran_source_file
#

#
# WARNING: don't run this script on source files unless
# you are sure no other local variables/structures that
# have the same variable names as the ones we are going
# to substitute. e.g. discrete.f has a local variable
# called u to store the random number, where this one
# should not be preprocessed to x4.... 
#

$declare_var = 0;
$declare_sub = 0;

while (<>) {
  chomp;

  if (!/^\s*c\s+/ && !/^\s*\*/) {
    if (/^\s*double precision/) {
      $declare_var = 1;
    } elsif ($declare_var == 1 && /^\s*&\s+/) {
    } else {
      $declare_var = 0;
    }

    if (/^\s*subroutine\s+/ || /^\s*call\s+/) {
      $declare_sub = 1;
    } elsif ($declare_sub == 1 && /^\s*&\s+/) {
    } else {
      $declare_sub = 0;
    }

    if ($declare_var == 1) {
      s/up\s*\(\s*n\s*,\s*n\s*\)/x1(n+1,n+1)/g;
      s/s1\s*\(\s*n\s*,\s*n\s*\)//g;
      s/s2\s*\(\s*n\s*,\s*n\s*\)/x2(n+1,n+1)/g;
      s/s3\s*\(\s*n\s*,\s*n\s*\)//g;
#      s/upisum\s*\(\s*n\s*,\s*n\s*\)/x3(n+1,n+1)/g;
#      s/upmsum\s*\(\s*n\s*,\s*n\s*\)//g;
      s/u\s*\(\s*n\+1\s*,\s*n\+1\s*\)/x4(n+3,n+3)/g;
      s/u1\s*\(\s*n\+1\s*,\s*n\+1\s*\)//g;
      s/(\s*,){2,}/,/g;
      s/^(\s*double precision\s*),/$1/g;
      s/^(\s*&\s*),/$1/g;
      s/^\s*double precision\s*$//g;
      s/^\s*&\s*$//g;
    } elsif ($declare_sub == 1) {

      s/(\W)up([^\w(])/$1x1$2/g;
      s/(\W)s1([^\w(])/$1$2/g;
      s/(\W)s2([^\w(])/$1x2$2/g;
      s/(\W)s3([^\w(])/$1$2/g;
#      s/(\W)upisum([^\w(])/$1x3$2/g;
#      s/(\W)upmsum([^\w(])/$1$2/g;
      s/(\W)u([^\w(])/$1x4$2/g;
      s/(\W)u1([^\w(])/$1$2/g;

      s/(\s*,){2,}/,/g;

#      s/^(\s*subroutine\s*\w+\(),/$1/g;
      s/\s*\(\s*,/\(/g;
      s/^(\s*&\s*),/$1/g;
      s/,\s*\)/\)/g;
      s/^\s*&\s*$//g;

    } else {

      s/(\W)up([^\w(])/$1x1$2/g;
      s/(\W)up\(\s*([^,]*)\s*,\s*([^)]*)\s*\)/$1x1\($2,1+$3\)/g;
      s/(\W)s1([^\w(])/$1x1$2/g;
      s/(\W)s1\(\s*([^,]*)\s*,\s*([^)]*)\s*\)/$1x1\($3,$2\)/g;

      s/(\W)s2([^\w(])/$1x2$2/g;
      s/(\W)s2\(\s*([^,]*)\s*,\s*([^)]*)\s*\)/$1x2\($2,1+$3\)/g;
      s/(\W)s3([^\w(])/$1x2$2/g;
      s/(\W)s3\(\s*([^,]*)\s*,\s*([^)]*)\s*\)/$1x2\($3,$2\)/g;

#      s/(\W)upisum([^\w(])/$1x3$2/g;
#      s/(\W)upisum\(\s*([^,]*)\s*,\s*([^)]*)\s*\)/$1x3\($2,1+$3\)/g;
#      s/(\W)upmsum([^\w(])/$1x3$2/g;
#      s/(\W)upmsum\(\s*([^,]*)\s*,\s*([^)]*)\s*\)/$1x3\($3,$2\)/g;

      s/(\W)u([^\w(])/$1x4$2/g;
      s/(\W)u\(\s*([^,]*)\s*,\s*([^)]*)\s*\)/$1x4\($2,2+$3\)/g;
      s/\'x4\'/\'u\'/g;
      s/(\W)u1([^\w(])/$1x4$2/g;
      s/(\W)u1\(\s*([^,]*)\s*,\s*([^)]*)\s*\)/$1x4\(2+$3,$2\)/g;

    }
    print $_, "\n";
  }
}
