#!/usr/bin/perl

#By Adam Wolenc for Wadsworth Center 2010-05-24
#Generate random sequences and submit to sfold
#Preserve any sequences that result in anomonlies

use strict;

#for (my $testnum=0; $testnum<250; ++$testnum) {
my $testnum =1;
my $fails = 0;
while (1) {
	#printf("%06d:", $testnum);

	my $slen = int(rand(30)+5);
	my $seq="";
	for (my $i=0;$i<$slen;++$i) {
		$seq.=int(rand(4));
	}
	$seq =~ tr/0123/ACGU/;
	#print "$seq\n";

	mkdir $seq or die("Cancelled");
	mkdir "$seq/out" or die("Cancelled");
	die("Cancelled") if (system ("echo '>$seq\\n$seq' > $seq/seq.dat"));
	chdir $seq or die("Cancelled");
	die("Cancelled") if (system("../../bin/sfold.X86_64.SUNOS -o out -p ../../param/ -s 1.000 -n 10000 seq.dat 2>/dev/null 1>/dev/null") > 0);
	die("Cancelled") if (system("../count_struct.pl > ../$seq.txt"));
	chdir ".." or die("Cancelled");
	die("Cancelled") if (system ("rm -rf $seq"));

	open (REPORT, "<$seq.txt") or die("Cancelled");
	my $keep=0;
	my $max_ratio=0;
	my $min_ratio=10000;
	while (<REPORT>) {
		if ($_ =~ /([0-9]+) *\( *([0-9]+)/) {
			if ($1 > 500 || $2 > 500) {
				my $ratio = $1 / $2;
				if ($ratio > $max_ratio) {
					$max_ratio = $ratio;
				}
				if ($ratio < $min_ratio) {
					$min_ratio = $ratio;
				}
				if ($ratio > 1.50 || $ratio < 0.66) {
					#print " $seq " if ($keep == 0);
					#printf("[%d %d %5.3f]", $1, $2, $ratio);
					$keep = 1;
				}
			}
		} else {
			die("Cancelled");
		}
	}
	close REPORT;

	if ($keep == 0) {
		unlink "$seq.txt" or die("Cancelled");
		#print "OK";
	} else {
		++$fails;
		#printf(" max:%5.3f 1/min:%5.3f (expect 1.0) Seq:%s ", $max_ratio, 1.0/$min_ratio, $seq);
		my $a = int($max_ratio*1000)/1000;
		my $b = int(1.0/$min_ratio*1000)/1000;
		print "[$fails failures in $testnum tests] max:$a 1/min:$b (expect 1.0) Seq:$seq\n";
		system ("echo \"$a\t$b\t$seq\" >> log.txt");
	}
	#print " [$fails failures in $testnum tests]\n";
	++$testnum;
}

