#!/bin/bash

TOMAKE=$1
if [ "$TOMAKE" == "" ];	then
	TOMAKE=10
fi
echo -n "Generating $TOMAKE tests"

EXNUM=$(ls -d -1 ex??? 2>/dev/null | sort | tail -1 | cut -c3-5)
if [ "$EXNUM" == "" ]; then
	EXNUM=0
	else let EXNUM++
fi
echo -n " starting with id "
printf ex%03d $EXNUM
echo "."

if [ ! -e "tb.sh" ]; then
	echo "#!/bin/sh" > tb.sh
	echo "" >> tb.sh
	chmod +x tb.sh
fi

for (( I=EXNUM; I<=EXNUM+TOMAKE; I++ ))
do
	DIRNAME=$(printf ex%03d $I)

	#make test dir and copy files
	mkdir $DIRNAME
	cp seed testrun $DIRNAME

	#add to test suite
	echo "cd $DIRNAME" >> tb.sh
	echo "LEN=\$(grep '^[ATCGUatgcu ]\+\$' seq.dat | tr -d \"\n\" | wc -c)" >> tb.sh
	echo "echo \"Input Sequence Length: \$LEN\"" >> tb.sh
	echo "time ./testrun" >> tb.sh
	echo "cd .." >> tb.sh
	echo "" >> tb.sh
done
