CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCC   file  TWINS.FOR  (Chapters 5 and 6)   41k   CCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      PROGRAM TWINS
CC
CC   THIS PROGRAM PERFORMS AGGLOMERATIVE NESTING (AGNES) USING THE
CC   GROUP AVERAGE METHOD OF SOKAL AND MICHENER (1958), AS WELL AS
CC   DIVISIVE ANALYSIS (DIANA) USING THE METHOD OF MCNAUGHTON-SMITH,
CC   WILLIAMS, DALE, AND MOCKETT (1964).
CC
CC   LIST OF FUNCTIONS AND SUBROUTINES: 
CC       MAIN UNIT
CC       SUBROUTINE ENTR
CC       SUBROUTINE QYN
CC       FUNCTION MEET
CC       SUBROUTINE NWLAB 
CC       SUBROUTINE STAND 
CC       SUBROUTINE DYSTA 
CC       SUBROUTINE AVERL 
CC       SUBROUTINE BANAG 
CC       SUBROUTINE SPLYT 
CC       SUBROUTINE SUPCL 
CC       SUBROUTINE BANDY 
CC
CC   THE FOLLOWING VECTORS AND MATRICES MUST BE DIMENSIONED IN THE
CC   MAIN PROGRAM ONLY:
CC       KWAN(MAXNN),NER(MAXNN),BAN(MAXNN),DVEC(MAXNN),JPLACE(MAXPP)
CC       X(MAXNN,MAXPP),JTMD(MAXPP),VALMD(MAXPP),DYS(MAXHH),HULP(MAXTT)
CC       LAB(3,MAXNN),JLAB(10,MAXPP),NUM(13)
CC   WHERE: 
CC       MAXNN = MAXIMAL NUMBER OF OBJECTS
CC       MAXTT = MAXIMAL TOTAL NUMBER OF VARIABLES
CC       MAXPP = MAXIMAL NUMBER OF VARIABLES USED IN THE ANALYSIS
CC       MAXHH = (MAXNN*(MAXNN-1))/2 + 1  
CC
CC
      DIMENSION KWAN(100),NER(100),BAN(100),DVEC(100),JPLACE(20)
      DIMENSION X(100,20),JTMD(20),VALMD(20),DYS(4951),HULP(80)
      CHARACTER LAB(3,100),JLAB(10,20),NUM(13),YNSAVE
      CHARACTER*30 FNAMEA,FNAMEB,FNAMEC
      CHARACTER*60 JFMT,NAME
      MAXNN=100
      MAXTT=80
      MAXPP=20
      MAXHH=4951
CC
CC   LOGICAL INPUT AND OUTPUT UNITS : 
CC      LUA = LOGICAL UNIT A (INPUT)
CC      LUB = LOGICAL UNIT B (OUTPUT) 
CC      LUC = LOGICAL UNIT C (OUTPUT OF DATA MATRIX)
CC   THE USER SHOULD ASSIGN TO LUA, LUB AND LUC THE NUMBERS USED BY
CC   HIS OWN COMPUTER: ONLY THE NEXT 3 STATEMENTS MUST BE CHANGED:
CC
      LUA=1 
      LUB=2 
      LUC=3
CC  
   10 CALL ENTR(MAXNN,MAXTT,MAXPP,MAXHH,X,DVEC,DYS,VALMD,JTMD,
     F JPLACE,HULP,LAB,JLAB,NUM,LUA,LUB,LUC,FNAMEA,FNAMEB,FNAMEC,
     F NAME,JFMT,NN,JPP,JDYSS,NSTAN,NDYST,LARGE,LGRAP,JLABS,NFF,
     F MDATA,YNSAVE,JALG)
CC  
CC   INSPECTION OF OBJECTS FOR MISSING VALUES 
CC
      IF(JDYSS.EQ.0)GO TO 20
      JPP=1
      GO TO 100
   20 IF(MDATA.EQ.0)GOTO 48
      JHALT=0
      DO 41 L=1,NN
      DO 42 J=1,JPP
      IF(JTMD(J).GE.0)GOTO 41
      IF(X(L,J).NE.VALMD(J))GOTO 41
   42 CONTINUE
      WRITE(LUB,9041)LAB(1,L),LAB(2,L),LAB(3,L)
      IF(FNAMEB.NE.'CON')WRITE(*,9041)LAB(1,L),LAB(2,L),LAB(3,L)
      JHALT=1 
   41 CONTINUE
CC
CC   INSPECTION OF VARIABLES FOR MISSING VALUES 
CC
      MYST=0
      DO 45 J=1,JPP 
      MYSJ=0
      IF(JTMD(J).GE.0)GOTO 45 
      DO 46 L=1,NN
      IF(X(L,J).EQ.VALMD(J))MYSJ=MYSJ+1 
   46 CONTINUE
      MYST=MYST+MYSJ
      IF(MYSJ.EQ.0)GOTO 45
      WRITE(LUB,9045)(JLAB(K,J),K=1,10),MYSJ
      IF(MYSJ.LT.NN)GOTO 45 
      WRITE(LUB,9047)(JLAB(J,K),K=1,10)
      IF(NFF.EQ.0)WRITE(LUB,9048)
      IF(FNAMEB.NE.'CON')WRITE(*,9047)(JLAB(J,K),K=1,10)
      IF(NFF.EQ.0.AND.FNAMEB.NE.'CON')WRITE(*,9048)
      JHALT=1 
   45 CONTINUE
      WRITE(LUB,9049)MYST 
      IF(JHALT.EQ.1)STOP
CC
CC   STANDARDIZATION AND DISTANCES
CC  
   48 IF(NSTAN.EQ.0)GO TO 70
      CALL STAND(NN,JPP,MAXNN,MAXPP,X,JTMD,VALMD,JHALT,JLAB,LUB,
     F FNAMEB)
      IF(JHALT.EQ.1)STOP
      IF(LARGE.EQ.0)GO TO 70
      WRITE(LUB,9031) 
      IF(MDATA.NE.0)WRITE(LUB,9032) 
      JPEND=JPP 
      IF(JPP.GT.8)JPEND=8 
      DO 60 L=1,NN
      WRITE(LUB,9033)LAB(1,L),LAB(2,L),LAB(3,L),(X(L,J),J=1,JPEND)
      IF(JPP.GT.8)WRITE(LUB,9040)(X(L,J),J=9,JPP) 
   60 CONTINUE
   70 CALL DYSTA(NN,JPP,MAXNN,MAXPP,MAXHH,X,DYS,NDYST,JTMD,VALMD,
     F LAB,JHALT,LUB,FNAMEB)
      IF(JHALT.EQ.1)STOP
  100 IF(LARGE.EQ.0)GO TO 130
      WRITE(LUB,9060) 
      WRITE(LUB,9033)LAB(1,1),LAB(2,1),LAB(3,1) 
      DO 120 L=2,NN 
      LSUBT=L-1 
      JPEND=LSUBT 
      IF(LSUBT.GT.8)JPEND=8 
      DO 110 J=1,LSUBT
      NLJ=MEET(L,J) 
      DVEC(J)=DYS(NLJ)
  110 CONTINUE
      WRITE(LUB,9033)LAB(1,L),LAB(2,L),LAB(3,L),(DVEC(J),J=1,JPEND)
      IF(LSUBT.GT.8)WRITE(LUB,9040)(DVEC(J),J=9,LSUBT)
  120 CONTINUE
  130 WRITE(LUB,9070)
  150 IF(JALG.EQ.2)GO TO 200
      CALL AVERL(NN,MAXNN,KWAN,NER,BAN,MAXHH,DYS,LUB)
      IF(LGRAP.NE.0)CALL BANAG(NN,MAXNN,BAN,NER,LAB,NUM,LUB)
      GO TO 300
  200 CALL SPLYT(NN,MAXNN,KWAN,NER,BAN,MAXHH,DYS,LUB)
      IF(LGRAP.NE.0)CALL BANDY(NN,MAXNN,BAN,NER,LAB,NUM,LUB)
  300 WRITE(*,9085)
      IF(YNSAVE.EQ.'Y'.AND.FNAMEB.EQ.'CON')WRITE(*,9090)FNAMEC
      IF(FNAMEB.NE.'PRN'.AND.FNAMEB.NE.'CON')WRITE(LUB,9095)FNAMEB
      IF(FNAMEB.EQ.'PRN')WRITE(*,9096)
      IF(FNAMEB.NE.'PRN'.AND.FNAMEB.NE.'CON')WRITE(*,9095)FNAMEB
      STOP
 9031 FORMAT(//26H STANDARDIZED MEASUREMENTS/1X,25(1H-)/) 
 9032 FORMAT(1X,33H ( 99.99 DENOTES A MISSING VALUE)//) 
 9033 FORMAT(1X,3A1,2X,8F9.2) 
 9040 FORMAT(6X,8F9.2)
 9041 FORMAT(/1X,7H OBJECT,3A1,29H CONTAINS ONLY MISSING VALUES,
     F21H AND MUST BE REMOVED./)
 9045 FORMAT(1X,9H VARIABLE,10A1,9H CONTAINS,I5,15H MISSING VALUES)
 9047 FORMAT(/1X,9H VARIABLE,10A1,29H CONTAINS ONLY MISSING VALUES,
     F21H AND MUST BE REMOVED.) 
 9048 FORMAT(1X,' (THIS CAN BE DONE BY CHANGING THE NUMBER OF'
     F' VARIABLES AND THE INPUT FORMAT.)'/)
 9049 FORMAT(//1X,38H THE TOTAL NUMBER OF MISSING VALUES IS,I7//) 
 9060 FORMAT(//21H DISSIMILARITY MATRIX/1X,20(1H-)/)
 9070 FORMAT(1X,5(/),16H CLUSTER RESULTS/1X,15(1H-))
 9085 FORMAT(/1X,'THIS RUN HAS BEEN SUCCESSFULLY COMPLETED')
 9090 FORMAT(/' Your data is written in file : ',A30)
 9095 FORMAT(/' The output is written in file : ',A30)
 9096 FORMAT(/' The output was sent to the printer')
      END 
CC
CC
      FUNCTION MEET(L,J)
      IF(L.GT.J)GO TO 10
      IF(L.EQ.J)GO TO 20
CC
CC    L IS LESS THAN J
CC
      MEET=(J-2)*(J-1)/2+L+1
      RETURN
CC
CC    J IS LESS THAN L
CC
   10 MEET=(L-2)*(L-1)/2+J+1
      RETURN
CC
CC    J EQUALS L
CC
   20 MEET=1
      RETURN
      END 
CC
CC
      SUBROUTINE NWLAB(NN,MAXNN,NUM,LAB)
      CHARACTER LAB(3,MAXNN),NUM(13)
      LLA=1 
      LLB=1 
      LLC=1 
      DO 50 J=1,NN
      IF(LLC.LT.10)GOTO 10
      LLC=0 
      IF(LLB.LT.10)GOTO 20
      LLB=0 
      LLA=LLA+1 
   20 LLB=LLB+1 
   10 LLC=LLC+1 
      LAB(1,J)=NUM(LLA) 
      LAB(2,J)=NUM(LLB) 
      LAB(3,J)=NUM(LLC) 
   50 CONTINUE
      RETURN
      END 
CC
CC
      SUBROUTINE QYN(YN,NYN)
      CHARACTER*1 YN
   10 READ(*,8000)YN
      IF(YN.EQ.'y')YN='Y'
      IF(YN.EQ.'n')YN='N'
      IF(YN.EQ.'Y')NYN=1
      IF(YN.EQ.'N')NYN=0
      IF(YN.EQ.'Y'.OR.YN.EQ.'N')GO TO 20
      WRITE(*,9000)
      GO TO 10
   20 RETURN
 8000 FORMAT(A1)
 9000 FORMAT(' NOT ALLOWED! PLEASE ENTER YOUR CHOICE AGAIN: '$)
      END
CC
CC
      SUBROUTINE STAND(NN,JPP,MAXNN,MAXPP,X,JTMD,VALMD,JHALT,JLAB,
     F LUB,FNAMEB)
      DIMENSION X(MAXNN,MAXPP),JTMD(MAXPP),VALMD(MAXPP)
      CHARACTER JLAB(10,MAXPP)
      CHARACTER*30 FNAMEB
      DO 200 J=1,JPP
      AVERA=0.0 
      STAM=0.0
      IF(JTMD(J).GE.0)GOTO 100
      NPRES=0 
      DO 20 L=1,NN
      IF(X(L,J).EQ.VALMD(J))GOTO 20 
      NPRES=NPRES+1 
      AVERA=AVERA+X(L,J)
   20 CONTINUE
      IF(NPRES.LE.1)GOTO 300
      RPRES=NPRES 
      AVERA=AVERA/RPRES 
      DO 50 L=1,NN
      IF(X(L,J).EQ.VALMD(J))GOTO 50 
      STAM=STAM+ABS(X(L,J)-AVERA) 
   50 CONTINUE
      STAM=STAM/RPRES
      WRITE(LUB,9305)(JLAB(K,J),K=1,10),AVERA,STAM
      IF(STAM.LE.0.0)GOTO 300 
      DO 60 L=1,NN
      IF(X(L,J).EQ.VALMD(J))GOTO 70 
      X(L,J)=(X(L,J)-AVERA)/STAM
      IF(X(L,J).GT.49.0)X(L,J)=49.0 
      IF(X(L,J).LT.(-49.0))X(L,J)=-49.0 
      GOTO 60 
   70 X(L,J)=99.99
   60 CONTINUE
      VALMD(J)=99.99
      GOTO 200
  100 DO 120 L=1,NN 
      AVERA=AVERA+X(L,J)
  120 CONTINUE
      RNN=NN
      AVERA=AVERA/RNN 
      DO 150 L=1,NN 
      STAM=STAM+ABS(X(L,J)-AVERA) 
  150 CONTINUE
      STAM=STAM/RNN
      WRITE(LUB,9305)(JLAB(K,J),K=1,10),AVERA,STAM
      IF(STAM.LE.0.0)GOTO 300
      DO 160 L=1,NN
      X(L,J)=(X(L,J)-AVERA)/STAM
      IF(X(L,J).GT.49.0)X(L,J)=49.0
      IF(X(L,J).LT.(-49.0))X(L,J)=-49.0
  160 CONTINUE
      GOTO 200
  300 JHALT=1 
      WRITE(LUB,9300)(JLAB(K,J),K=1,10)
      IF(FNAMEB.NE.'CON')WRITE(*,9300)(JLAB(K,J),K=1,10)
  200 CONTINUE
      RETURN
 9300 FORMAT(/'  THE MEAN DEVIATION OF VARIABLE ',10A1/
     F ' IS ZERO (UP TO COMPUTER PRECISION).'/'  PLEASE RUN'
     F ' THE PROGRAM AGAIN WITHOUT THIS VARIABLE.'/)
 9305 FORMAT('  VARIABLE ',10A1,' HAS AVERAGE ',F10.3,
     F ',    MEAN DEVIATION ',F10.3)
      END 
CC
CC
      SUBROUTINE DYSTA(NN,JPP,MAXNN,MAXPP,MAXHH,X,DYS,NDYST,JTMD,
     F VALMD,LAB,JHALT,LUB,FNAMEB)
      DIMENSION X(MAXNN,MAXPP),DYS(MAXHH),JTMD(MAXPP),VALMD(MAXPP)
      CHARACTER LAB(3,MAXNN)
      CHARACTER*30 FNAMEB
      PP=JPP
      NLK=1 
      DYS(1)=0.0
      DO 100 L=2,NN 
      LSUBT=L-1 
      DO 20 K=1,LSUBT 
      CLK=0.0 
      NLK=NLK+1 
      NPRES=0 
      DO 30 J=1,JPP 
      IF(JTMD(J).GE.0)GOTO 40 
      IF(X(L,J).EQ.VALMD(J))GOTO 30 
      IF(X(K,J).EQ.VALMD(J))GOTO 30 
   40 NPRES=NPRES+1 
      IF(NDYST.NE.1)GOTO 50 
      CLK=CLK+(X(L,J)-X(K,J))*(X(L,J)-X(K,J)) 
      GOTO 30 
   50 CLK=CLK+ABS(X(L,J)-X(K,J))
   30 CONTINUE
      RPRES=NPRES 
      IF(NPRES.NE.0)GOTO 60 
      JHALT=1 
      WRITE(LUB,9400)LAB(1,L),LAB(2,L),LAB(3,L),
     F LAB(1,K),LAB(2,K),LAB(3,K)
      IF(FNAMEB.NE.'CON')WRITE(*,9400)LAB(1,L),LAB(2,L),LAB(3,L),
     F LAB(1,K),LAB(2,K),LAB(3,K)
      DYS(NLK)=0.0
      GOTO 20 
   60 IF(NDYST.NE.1)GOTO 70 
      DYS(NLK)=SQRT(CLK*(PP/RPRES)) 
      GOTO 20 
   70 DYS(NLK)=CLK*(PP/RPRES) 
   20 CONTINUE
  100 CONTINUE
      RETURN
 9400 FORMAT(2X,'OBJECTS ',3A1,' AND ',3A1,
     F28H HAVE NO COMMON MEASUREMENTS)
      END 
CC
CC
      SUBROUTINE AVERL(NN,MAXNN,KWAN,NER,BAN,MAXHH,DYS,LUB) 
      DIMENSION KWAN(MAXNN),DYS(MAXHH),NER(MAXNN),BAN(MAXNN)
      NCLU=NN-1 
CC      INITIALIZATION
      DO 10 L=1,NN
      KWAN(L)=1 
      NER(L)=L
   10 CONTINUE
CC
CC    FIND CLOSEST CLUSTERS
CC
  100 J=1 
   80 J=J+1 
      IF(KWAN(J).EQ.0)GOTO 80 
      NEJ=MEET(1,J) 
      SMALD=DYS(NEJ)*1.1+1.0
      NNS=NN-1
      DO 120 L=1,NNS  
      IF(KWAN(L).EQ.0)GO TO 120 
      LMUCH=L+1 
      DO 110 J=LMUCH,NN 
      IF(KWAN(J).EQ.0)GO TO 110 
      NLJ=MEET(L,J) 
      IF(DYS(NLJ).GT.SMALD)GO TO 110
      SMALD=DYS(NLJ)
      LA=L
      LB=J  
  110 CONTINUE
  120 CONTINUE
CC
CC    DETERMINE LFYRS AND LLAST
CC
      DO 200 L=1,NN 
      IF(NER(L).EQ.LA)LFYRS=L 
      IF(NER(L).EQ.LB)LLAST=L 
  200 CONTINUE
      BAN(LLAST)=SMALD
CC
CC    IF THE TWO CLUSTERS ARE NEXT TO EACH OTHER,
CC    NER MUST NOT BE CHANGED
CC
      LNEXT=LFYRS+KWAN(LA)
      IF(LNEXT.EQ.LLAST)GOTO 230
CC
CC    UPDATING NER AND BAN
CC
      LPUT=LFYRS+KWAN(LA) 
      LNUM=LLAST-LPUT 
      DO 220 L=1,LNUM 
      LKA=NER(LPUT) 
      AKB=BAN(LPUT) 
      LENDA=LLAST+KWAN(LB)-2
      LENDB=LENDA+1 
      DO 210 J=LPUT,LENDA 
      NER(J)=NER(J+1) 
      BAN(J)=BAN(J+1) 
  210 CONTINUE
      NER(LENDB)=LKA
      BAN(LENDB)=AKB
  220 CONTINUE
CC
CC    CALCULATE NEW DISSIMILARITIES
CC
  230 DO 240 LQ=1,NN
      IF(LQ.EQ.LA.OR.LQ.EQ.LB)GO TO 240 
      IF(KWAN(LQ).EQ.0)GO TO 240
      TA=KWAN(LA) 
      TB=KWAN(LB) 
      FA=TA/(TA+TB) 
      FB=TB/(TA+TB) 
      NAQ=MEET(LA,LQ) 
      NBQ=MEET(LB,LQ) 
      DYS(NAQ)=FA*DYS(NAQ)+FB*DYS(NBQ)
  240 CONTINUE
      IF(NCLU.NE.1)GOTO 250 
      WRITE(LUB,9100) 
      WRITE(LUB,9110)(NER(L),L=1,NN)
      WRITE(LUB,9120) 
      WRITE(LUB,9130)(BAN(L),L=2,NN)
  250 KWAN(LA)=KWAN(LA)+KWAN(LB)
      KWAN(LB)=0
      NCLU=NCLU-1 
      IF(NCLU.GT.0)GOTO 100 
      RETURN
 9100 FORMAT(//37H THE FINAL ORDERING OF THE OBJECTS IS/) 
 9110 FORMAT(5(I9,6X))
 9120 FORMAT(//41H THE DISSIMILARITIES BETWEEN CLUSTERS ARE/) 
 9130 FORMAT(3X,5F15.3) 
      END 
CC
CC
      SUBROUTINE BANAG(NN,MAXNN,BAN,NER,LAB,NUM,LUB)
      DIMENSION BAN(MAXNN),NER(MAXNN)
      CHARACTER*1 LAB(3,MAXNN),JDRAW(78),NUM(13),JBLAN,JSTAR,JSEPA
      JBLAN=NUM(11)
      JSTAR=NUM(12)
      JSEPA=NUM(13)
      WRITE(LUB,9000) 
      WRITE(LUB,9200) 
      WRITE(LUB,9210) 
      WRITE(LUB,9220) 
      SUP=0.0 
      DO 70 K=2,NN
      IF(BAN(K).GT.SUP)SUP=BAN(K) 
   70 CONTINUE
      AC=0.0
      DO 80 K=1,NN
      KEARL=K 
      IF(K.EQ.1)KEARL=2 
      KAFTE=K+1 
      IF(K.EQ.NN)KAFTE=NN 
      SYZE=BAN(KEARL) 
      IF(BAN(KAFTE).LT.SYZE)SYZE=BAN(KAFTE) 
      AC=AC+1.0-(SYZE/SUP)
      LEMPT=INT((SYZE/SUP)*75.0+0.01) 
      IF(LEMPT.EQ.0)GOTO 82 
      DO 81 L=1,LEMPT 
      JDRAW(L)=JBLAN
   81 CONTINUE
   82 LADD=LEMPT+1
      KAUNT=0 
      NCASE=NER(K)
      DO 83 L=LADD,78 
      KAUNT=KAUNT+1 
      IF(KAUNT.EQ.5)KAUNT=1 
      IF(KAUNT.EQ.1)JDRAW(L)=LAB(1,NCASE) 
      IF(KAUNT.EQ.2)JDRAW(L)=LAB(2,NCASE) 
      IF(KAUNT.EQ.3)JDRAW(L)=LAB(3,NCASE) 
      IF(KAUNT.EQ.4)JDRAW(L)=JSEPA
   83 CONTINUE
      WRITE(LUB,9100)(JDRAW(J),J=1,78)
      IF(K.EQ.NN)GO TO 90 
      SYZE=BAN(KAFTE) 
      LEMPT=INT((SYZE/SUP)*75.0+0.01) 
      IF(LEMPT.EQ.0)GOTO 86 
      DO 85 L=1,LEMPT 
      JDRAW(L)=JBLAN
   85 CONTINUE
   86 LADD=LEMPT+1
      DO 87 L=LADD,78 
      JDRAW(L)=JSTAR
   87 CONTINUE
      WRITE(LUB,9100)(JDRAW(J),J=1,78)
   80 CONTINUE
   90 WRITE(LUB,9200) 
      WRITE(LUB,9210) 
      WRITE(LUB,9220) 
      WRITE(LUB,9300)SUP
      RNN=NN
      AC=AC/RNN 
      WRITE(LUB,9310)AC 
      RETURN
 9000 FORMAT(///34X,12(1H*)/34X,1H*,10X,1H*/34X,1H*,8H  BANNER, 
     F2X,1H*/34X,1H*,10X,1H*/34X,12(1H*)/)
 9100 FORMAT(1X,78A1) 
 9200 FORMAT(//1X,25(3H0  ),1H1/1X,26(3H.  )) 
 9210 FORMAT(1X,45H0  0  0  1  1  2  2  2  3  3  4  4  4  5  5  , 
     F31H6  6  6  7  7  8  8  8  9  9  0) 
 9220 FORMAT(1X,5(15H0  4  8  2  6  ),1H0//)
 9300 FORMAT(//28H THE ACTUAL HIGHEST LEVEL IS,3X,F25.10) 
 9310 FORMAT(//38H THE AGGLOMERATIVE COEFFICIENT OF THIS, 
     F12H DATA SET IS,2X,F5.2)
      END 
CC
CC
      SUBROUTINE SPLYT(NN,MAXNN,KWAN,NER,BAN,MAXHH,DYS,LUB) 
      DIMENSION KWAN(MAXNN),DYS(MAXHH),NER(MAXNN),BAN(MAXNN)
CC
CC    INITIALIZATION
CC
      NCLU=1
      NHALF=NN*(NN-1)/2+1 
      DO 10 L=1,NN
      KWAN(L)=0 
      BAN(L)=0. 
      NER(L)=L
   10 CONTINUE
      KWAN(1)=NN
      JA=1
CC
CC    COMPUTATION OF DIAMETER OF DATA SET
CC
      CS=0.0
      K=0 
   20 K=K+1 
      IF(DYS(K).GT.CS)CS=DYS(K) 
      IF(K.LT.NHALF)GO TO 20
CC
CC    PREPARE FOR SPLITTING
CC
   30 JB=JA+KWAN(JA)-1
      JMA=JB
CC
CC    SPECIAL CASE OF A PAIR OF OBJECTS
CC
      IF(KWAN(JA).NE.2)GO TO 50 
      KWAN(JA)=1
      KWAN(JB)=1
      JAN=NER(JA) 
      JBN=NER(JB) 
      JAB=MEET(JAN,JBN) 
      BAN(JB)=DYS(JAB)
      GO TO 400 
CC
CC    FINDING FIRST OBJECT TO BE SHIFTED
CC
   50 BYGSD=-1. 
      DO 110 L=JA,JB
      LNER=NER(L) 
      SD=0. 
      DO 100 J=JA,JB
      JNER=NER(J) 
      NLJ=MEET(LNER,JNER) 
      SD=SD+DYS(NLJ)
  100 CONTINUE
      IF(SD.LE.BYGSD)GO TO 110
      BYGSD=SD
      LNDSD=L 
  110 CONTINUE
CC
CC    SHIFTING THE FIRST OBJECT
CC
      KWAN(JA)=KWAN(JA)-1 
      KWAN(JB)=1
      IF(JB.EQ.LNDSD)GO TO 115
      LCHAN=NER(LNDSD)
      LMM=JB-1
      DO 112 LMMA=LNDSD,LMM 
      LMMB=LMMA+1 
      NER(LMMA)=NER(LMMB) 
  112 CONTINUE
      NER(JB)=LCHAN 
  115 SPLYN=0.
      JMA=JB-1
CC
CC    FINDING THE NEXT OBJECT TO BE SHIFTED
CC
  120 SPLYN=SPLYN+1.
      REST=JMA-JA 
      BDYFF=-1. 
      DO 150 L=JA,JMA 
      LNER=NER(L) 
      DA=0. 
      DO 130 J=JA,JMA 
      JNER=NER(J) 
      NLJ=MEET(LNER,JNER) 
      DA=DA+DYS(NLJ)
  130 CONTINUE
      DA=DA/REST
      DB=0. 
      JMB=JMA+1 
      DO 140 J=JMB,JB 
      JNER=NER(J) 
      NLJ=MEET(LNER,JNER) 
      DB=DB+DYS(NLJ)
  140 CONTINUE
      DB=DB/SPLYN 
      DYFF=DA-DB
      IF(DYFF.LE.BDYFF)GO TO 150
      BDYFF=DYFF
      JAWAY=L 
  150 CONTINUE
      JMB=JMA+1
CC
CC    SHIFTING THE NEXT OBJECT WHEN NECESSARY
CC
      IF(BDYFF.LE.0.)GO TO 200
      IF(JMA.EQ.JAWAY)GO TO 165 
      LCHAN=NER(JAWAY)
      LMZ=JMA-1 
      DO 160 LXX=JAWAY,LMZ
      LXXP=LXX+1
      NER(LXX)=NER(LXXP)
  160 CONTINUE
      NER(JMA)=LCHAN
  165 DO 170 LXX=JMB,JB 
      LXY=LXX-1 
      IF(NER(LXY).LT.NER(LXX))GO TO 180 
      LCHAN=NER(LXY)
      NER(LXY)=NER(LXX) 
      NER(LXX)=LCHAN
  170 CONTINUE
  180 KWAN(JA)=KWAN(JA)-1 
      KWAN(JMA)=KWAN(JMB)+1 
      KWAN(JMB)=0 
      JMA=JMA-1 
      JMB=JMA+1 
      IF(JMA.NE.JA)GO TO 120
CC
CC    SWITCH THE TWO PARTS WHEN NECESSARY
CC
  200 IF(NER(JA).LT.NER(JMB))GO TO 300
      LXXA=JA 
      DO 220 LGRB=JMB,JB
      LXXA=LXXA+1 
      LCHAN=NER(LGRB) 
      DO 210 LXY=LXXA,LGRB
      LXF=LGRB-LXY+LXXA 
      LXG=LXF-1 
      NER(LXF)=NER(LXG) 
  210 CONTINUE
      NER(LXG)=LCHAN
  220 CONTINUE
      LLQ=KWAN(JMB) 
      KWAN(JMB)=0 
      JMA=JA+JB-JMA-1 
      JMB=JMA+1 
      KWAN(JMB)=KWAN(JA)
      KWAN(JA)=LLQ
CC
CC    COMPUTE LEVEL FOR BANNER
CC
  300 IF(NCLU.EQ.1)BAN(JMB)=CS
      IF(NCLU.EQ.1)GO TO 400
      CALL SUPCL(MAXHH,DYS,JA,JB,AREST,MAXNN,NER) 
      BAN(JMB)=AREST
  400 NCLU=NCLU+1 
      IF(NCLU.EQ.2)WRITE(LUB,9000)NN,JMA,KWAN(JMB)
      IF(NCLU.EQ.NN)GOTO 500
CC
CC    CONTINUE SPLITTING UNTIL ALL OBJECTS ARE SEPARATED
CC
      IF(JB.EQ.NN)GO TO 430 
  420 JA=JA+KWAN(JA)
      IF(JA.GT.NN)GO TO 430 
      IF(KWAN(JA).LE.1)GO TO 420
      GO TO 30
  430 JA=1
      IF(KWAN(JA).EQ.1)GO TO 420
      GO TO 30
  500 WRITE(LUB,9100) 
      WRITE(LUB,9110)(NER(L),L=1,NN)
      WRITE(LUB,9120) 
      WRITE(LUB,9130)(BAN(L),L=2,NN)
      RETURN
 9000 FORMAT(//22H AT THE FIRST STEP THE,I4,20H OBJECTS ARE DIVIDED,
     F5H INTO/3X,I4,12H OBJECTS AND,I4,8H OBJECTS)
 9100 FORMAT(//37H THE FINAL ORDERING OF THE OBJECTS IS/) 
 9110 FORMAT(5(I9,6X))
 9120 FORMAT(//34H THE DIAMETERS OF THE CLUSTERS ARE/)
 9130 FORMAT(3X,5F15.3) 
      END 
CC
CC  
      SUBROUTINE SUPCL(MAXHH,DYS,KKA,KKB,AREST,MAXNN,NER) 
      DIMENSION DYS(MAXHH),NER(MAXNN) 
      KKC=KKB-1 
      AREST=0.
      DO 20 L=KKA,KKC 
      LNER=NER(L) 
      KKD=L+1 
      DO 10 J=KKD,KKB 
      JNER=NER(J) 
      MLJ=MEET(LNER,JNER) 
      IF(DYS(MLJ).GT.AREST)AREST=DYS(MLJ) 
   10 CONTINUE
   20 CONTINUE
      RETURN
      END 
CC
CC
      SUBROUTINE BANDY(NN,MAXNN,BAN,NER,LAB,NUM,LUB)
      DIMENSION BAN(MAXNN),NER(MAXNN)
      CHARACTER*1 LAB(3,MAXNN),JDRAW(78),NUM(13),JSTAR,JSEPA
      JSTAR=NUM(12)
      JSEPA=NUM(13)
      WRITE(LUB,9000) 
      WRITE(LUB,9200) 
      WRITE(LUB,9210) 
      WRITE(LUB,9220) 
      SUP=0.0 
      DO 70 K=2,NN
      IF(BAN(K).GT.SUP)SUP=BAN(K) 
   70 CONTINUE
      DO 71 K=2,NN
      BAN(K)=BAN(K)/SUP   
   71 CONTINUE
      DC=0.0
      DO 80 K=1,NN
      NCASE=NER(K)
      DO 81 L=1,19
      LALFA=(L-1)*4+1 
      LBETA=(L-1)*4+2 
      LGAMA=(L-1)*4+3 
      LDELT=L*4 
      JDRAW(LALFA)=LAB(1,NCASE) 
      JDRAW(LBETA)=LAB(2,NCASE) 
      JDRAW(LGAMA)=LAB(3,NCASE) 
      JDRAW(LDELT)=JSEPA
   81 CONTINUE
      JDRAW(77)=LAB(1,NCASE)
      JDRAW(78)=LAB(2,NCASE)
      KEARL=K 
      IF(K.EQ.1)KEARL=2 
      KAFTE=K+1 
      IF(K.EQ.NN)KAFTE=NN 
      SYZE=BAN(KEARL) 
      IF(BAN(KAFTE).LT.SYZE)SYZE=BAN(KAFTE) 
      DC=DC+1.0-SYZE
      LENGT=INT((1.0-SYZE)*75.0+0.01)+3 
      WRITE(LUB,9100)(JDRAW(J),J=1,LENGT) 
      IF(K.EQ.NN)GO TO 90 
      SYZE=BAN(KAFTE) 
      LENGT=INT((1.0-SYZE)*75.0+0.01)+3 
      DO 82 L=1,LENGT 
      JDRAW(L)=JSTAR
   82 CONTINUE
      WRITE(LUB,9100)(JDRAW(J),J=1,LENGT) 
   80 CONTINUE
   90 WRITE(LUB,9200) 
      WRITE(LUB,9210) 
      WRITE(LUB,9220) 
      WRITE(LUB,9300)SUP
      RNN=NN
      DC=DC/RNN 
      WRITE(LUB,9310)DC 
      RETURN
 9000 FORMAT(///34X,12(1H*)/34X,1H*,10X,1H*/34X,1H*,8H  BANNER, 
     F2X,1H*/34X,1H*,10X,1H*/34X,12(1H*)/)
 9100 FORMAT(1X,78A1) 
 9200 FORMAT(//3X,1H1,25(3H  0)/3X,26(3H.  )) 
 9210 FORMAT(3X,45H0  9  9  8  8  8  7  7  6  6  6  5  5  4  4  , 
     F31H4  3  3  2  2  2  1  1  0  0  0) 
 9220 FORMAT(3X,5(15H0  6  2  8  4  ),1H0//)
 9300 FORMAT(//40H THE ACTUAL DIAMETER OF THIS DATA SET IS,3X,F25.10) 
 9310 FORMAT(//33H THE DIVISIVE COEFFICIENT OF THIS,
     F12H DATA SET IS,2X,F5.2)
      END
CC
CC
      SUBROUTINE ENTR(MAXNN,MAXTT,MAXPP,MAXHH,X,DVEC,DYS,VALMD,JTMD,
     F JPLACE,HULP,LAB,JLAB,NUM,LUA,LUB,LUC,FNAMEA,FNAMEB,FNAMEC,
     F NAME,JFMT,NN,JPP,JDYSS,NSTAN,NDYST,LARGE,LGRAP,JLABS,
     F NFF,MDATA,YNSAVE,JALG)
      DIMENSION X(MAXNN,MAXPP),DVEC(MAXNN),DYS(MAXHH)
      DIMENSION VALMD(MAXPP),JTMD(MAXPP),JPLACE(MAXPP),HULP(MAXTT)
      CHARACTER NUM(13)
      CHARACTER STAN,DYSS,DYST,CYNFF,YNSAVE,CARGE,CGRAP,CLABS,CMDT
      CHARACTER CALG,CDATA,CYNK,CEX,LAB(3,MAXNN),JLAB(10,MAXPP)
      CHARACTER*30 FNAMEA,FNAMEB,FNAMEC
      CHARACTER*60 JFMT,NAME
      NUM(1)='0'
      NUM(2)='1'
      NUM(3)='2'
      NUM(4)='3'
      NUM(5)='4'
      NUM(6)='5'
      NUM(7)='6'
      NUM(8)='7'
      NUM(9)='8'
      NUM(10)='9'
      NUM(11)=' '
      NUM(12)='*'
      NUM(13)='+'
      YNSAVE=' '
      NSTAN=0
      WRITE(*,9000)
   50 WRITE(*,9010)
   60 READ(*,8500)CALG
      JALG=0
      IF(CALG.EQ.'A'.OR.CALG.EQ.'a')JALG=1
      IF(CALG.EQ.'D'.OR.CALG.EQ.'d')JALG=2
      IF(JALG.NE.0)GO TO 70
      WRITE(*,9520)
      GO TO 60
   70 IF(JALG.EQ.1)WRITE(*,9500)
      IF(JALG.EQ.2)WRITE(*,9501)
      WRITE(*,9505)
      IF(JALG.EQ.1)WRITE(*,9506)
      IF(JALG.EQ.2)WRITE(*,9507)
      WRITE(*,9508)
  100 WRITE(*,9510)
  110 READ(*,8500)DYSS
      JDYSS=2
      IF(DYSS.EQ.'D'.OR.DYSS.EQ.'d')JDYSS=1
      IF(DYSS.EQ.'M'.OR.DYSS.EQ.'m')JDYSS=0
      IF(JDYSS.NE.2)GO TO 120
      WRITE(*,9520)
      GO TO 110
  120 WRITE (*,9525)MAXNN
  130 WRITE (*,9530)MAXNN
      READ (*,*) NN
      IF(NN.LE.MAXNN) GOTO 140
      WRITE(*,9520)
      GOTO 130
  140 IF(NN.GE.3)GO TO 200
      WRITE(*,9540)
      GOTO 130
  200 IF(JDYSS.EQ.1)GO TO 500
CC
CC   IN THIS SECTION SPECIFIC INFORMATION RELATED TO THE INPUT
CC   OF MEASUREMENTS IS ENTERED :
CC        TOTAL NUMBER OF VARIABLES (JPPT)
CC        NUMBER OF VARIABLES TO BE USED IN THE ANALYSIS (JPP)
CC        VARIABLES TO BE USED IN THE ANALYSIS, AND THEIR LABELS
CC        CHOICE OF STANDARDIZATION
CC        CHOICE OF EUCLIDEAN OR MANHATTAN DISTANCE.
CC
      WRITE(*,9620)MAXTT,MAXPP
  300 WRITE(*,9630)MAXTT
      READ(*,*)JPPT
      IF(JPPT.NE.1)GO TO 310
      JPP=1
      GO TO 350
  310 IF(JPPT.GE.1.AND.JPPT.LE.MAXTT)GO TO 320
      WRITE(*,9520)
      GO TO 300
  320 JPPA=MAXPP
      IF(JPPA.GT.JPPT)JPPA=JPPT
  330 WRITE(*,9640)JPPA
      READ(*,*)JPP
      IF(JPP.GE.1.AND.JPP.LE.JPPA)GO TO 340
      WRITE(*,9520)
      GO TO 330
  340 IF(JPPT.GT.JPP)GO TO 370
  350 WRITE(*,9650)
      DO 360 J=1,JPP
      JPLACE(J)=J
      WRITE(*,9660)J
      READ(*,8510)(JLAB(K,J),K=1,10)
  360 CONTINUE
      GO TO 410
  370 WRITE(*,9670)
      DO 400 J=1,JPP
  380 WRITE(*,9680)J
      READ(*,8520)JPLACE(J),(JLAB(K,J),K=1,10)
      IF(JPLACE(J).LT.1.OR.JPLACE(J).GT.JPPT)GO TO 380
      IF(J.EQ.1)GO TO 400
      JPPL=J-1
      DO 390 JK=1,JPPL
      IF(JPLACE(JK).NE.JPLACE(J))GO TO 390
      WRITE(*,9690)
      GO TO 380
  390 CONTINUE
  400 CONTINUE
  410 WRITE(*,9700)
      CALL QYN(STAN,NSTAN)
      WRITE(*,9710)
  420 READ(*,8500)DYST
      NDYST=0
      IF(DYST.EQ.'E'.OR.DYST.EQ.'e')NDYST=1
      IF(DYST.EQ.'M'.OR.DYST.EQ.'m')NDYST=2
      IF(NDYST.NE.0)GO TO 500
      WRITE(*,9520)
      GO TO 420
CC
CC   OUTPUT SECTION :
CC      TITLE
CC      SMALL OR LARGE OUTPUT
CC      GRAPHICAL OUTPUT (BANNER)
CC      LABELS OF OBJECTS
CC
  500 WRITE (*,9720)
      READ (*,8530)NAME
      WRITE(*,9730)
      IF(NSTAN.EQ.1)WRITE(*,9732)
      IF(NSTAN.EQ.0)WRITE(*,9734)
      CALL QYN(CARGE,LARGE)
      WRITE(*,9740)
      CALL QYN(CGRAP,LGRAP)
      WRITE(*,9750)
      CALL QYN(CLABS,JLABS)
      IF(JLABS.EQ.0)GO TO 520
      WRITE(*,9760)
      DO 510 J=1,NN
      WRITE(*,9770)J
      READ(*,8540)LAB(1,J),LAB(2,J),LAB(3,J)
  510 CONTINUE
      GO TO 550
  520 CALL NWLAB(NN,MAXNN,NUM,LAB)
CC
CC   FORMATS
CC
  550 WRITE (*,9780)
      CALL QYN(CYNFF,NFF)
      IF (CYNFF.EQ.'Y') GOTO 600
      WRITE(*,9790)
      READ (*,8530)JFMT
CC
CC   STATUS OF INPUT AND OUTPUT: KEYBOARD, SCREEN, PRINTER, FILES.
CC
  600 WRITE(*,9800)
      READ(*,8550)FNAMEA
      IF(FNAMEA.EQ.'KEY'.OR.FNAMEA.EQ.'key'.OR.FNAMEA.EQ.'Key')GOTO 610
      YNSAVE='N'
      NSAVE=0
      GO TO 620
  610 FNAMEA='CON'
      WRITE(*,9810)
      CALL QYN(YNSAVE,NSAVE)
      IF (YNSAVE.EQ.'N')GO TO 620
  612 WRITE(*,9820)
      READ(*,8550)FNAMEC
      OPEN(LUC,FILE=FNAMEC,STATUS='NEW',IOSTAT=NEG,ERR=615)
      GO TO 620
  615 IF(NEG.NE.1027.AND.NEG.NE.1030.AND.NEG.NE.1032.
     F AND.NEG.NE.1033.AND.NEG.NE.1045)GO TO 616
      WRITE(*,9831)
      GO TO 612
  616 WRITE(*,9834)NEG
      STOP
  620 OPEN(LUA,FILE=FNAMEA,IOSTAT=NER,ERR=630)
      GO TO 640
  630 IF(FNAMEA.NE.'CON'.AND.(NER.EQ.1027.OR.NER.EQ.1030.OR.
     F NER.EQ.1032.OR.NER.EQ.1033))THEN
      WRITE(*,9832)
      GO TO 600
      ENDIF
      WRITE(*,9834)NER
      STOP
  640 WRITE(*,9830)
      READ(*,8550)FNAMEB
      IF(FNAMEB.EQ.'con'.OR.FNAMEB.EQ.'Con')FNAMEB='CON'
      IF(FNAMEB.EQ.'prn'.OR.FNAMEB.EQ.'Prn')FNAMEB='PRN'
      IF (FNAMEB.EQ.'CON'.OR.FNAMEB.EQ.'PRN')OPEN(LUB,FILE=FNAMEB)
      IF (.NOT.(FNAMEB.EQ.'CON'.OR.FNAMEB.EQ.'PRN'))OPEN(LUB,
     F FILE=FNAMEB,STATUS='NEW',IOSTAT=NET,ERR=650)
      GO TO 690
  650 IF(NET.NE.1027.AND.NET.NE.1030.AND.NET.NE.1032.
     F AND.NET.NE.1033.AND.NET.NE.1045)GO TO 660
      WRITE(*,9831)
      GO TO 640
  660 WRITE(*,9834)NET
      STOP
  690 IF(JDYSS.EQ.1)GO TO 800
CC
CC   SECTION ON MISSING DATA
CC
      WRITE (*,9840)
      CALL QYN(CDATA,MDATA)
      IF(MDATA.EQ.0) GO TO 740
      WRITE(*,9850)
      CALL QYN(CMDT,MDT)
      IF(MDT.EQ.0)GO TO 710
      WRITE(*,9860)
      READ(*,*)VVAL
      DO 700 J=1,JPP
      JTMD(J)=-1
      VALMD(J)=VVAL
  700 CONTINUE
      GO TO 800
  710 DO 730 J=1,JPP
      WRITE (*,9870)(JLAB(K,J),K=1,10)
      CALL QYN(CYNK,NYNK)
      IF (CYNK.EQ.'Y')GO TO 720
      JTMD(J)=1
      VALMD(J)=-99.99
      GO TO 730
  720 JTMD(J)=-1
      WRITE(*,9880)
      READ (*,*) VALMD(J)
  730 CONTINUE
      GO TO 800
  740 DO 750 J=1,JPP
      JTMD(J)=1
      VALMD(J)=-99.99
  750 CONTINUE
CC
CC   RECAPITULATION OF OPTIONS
CC
  800 WRITE(*,9890)
      WRITE(*,9900)
      WRITE(*,9905)NAME
      WRITE(*,9910)NN
      IF(CLABS.EQ.'Y')WRITE(*,8070)
      IF(CLABS.EQ.'N')WRITE(*,8075)
      IF(JDYSS.EQ.1)WRITE(*,8080)
      IF(JDYSS.EQ.0)WRITE(*,8085)
      IF(CARGE.EQ.'Y')WRITE(*,8090)
      IF(CARGE.EQ.'N')WRITE(*,8095)
      IF(CGRAP.EQ.'Y')WRITE(*,8100)
      IF(CGRAP.EQ.'N')WRITE(*,8105)
      IF(JDYSS.EQ.1)GO TO 840
      IF(JPPT.GT.1)GO TO 810
      WRITE(*,8118)
      GO TO 820
  810 WRITE(*,8115)JPPT
      IF(JPP.GT.1)WRITE(*,8116)JPP
      IF(JPP.EQ.1)WRITE(*,8119)(JLAB(K,1),K=1,10),JPLACE(1)
  820 IF(STAN.EQ.'Y')WRITE(*,8120)
      IF(STAN.EQ.'N')WRITE(*,8125)
      IF(NDYST.EQ.1)WRITE(*,8130)
      IF(NDYST.EQ.2)WRITE(*,8135)
      IF(CDATA.EQ.'N')WRITE(*,8145)
      IF(CDATA.EQ.'N')GO TO 830
      IF(CMDT.EQ.'N')WRITE(*,8140)
      IF(CMDT.EQ.'Y')WRITE(*,8142)
      IF(CMDT.EQ.'Y')WRITE(*,*)VVAL
  830 IF (CYNFF.EQ.'Y') WRITE(*,8160)
      IF (CYNFF.EQ.'N') WRITE(*,8165) JFMT
      GO TO 850
  840 IF (CYNFF.EQ.'Y') WRITE(*,8170)
      IF (CYNFF.EQ.'N') WRITE(*,8175) JFMT
  850  IF (FNAMEA.NE.'CON') WRITE(*,8039) FNAMEA
       IF (FNAMEA.EQ.'CON') WRITE(*,8034)
       IF (YNSAVE.EQ.'Y') WRITE(*,8038) FNAMEC
      WRITE(*,8040) FNAMEB
      WRITE (*,8030)
      CALL QYN(CEX,NEX)
      IF (CEX.NE.'Y')GO TO 50
      IF(FNAMEB.EQ.'CON')GO TO 900
      IF(JALG.EQ.1)WRITE(LUB,9500)
      IF(JALG.EQ.2)WRITE(LUB,9501)
      WRITE(LUB,9505)
      IF(JALG.EQ.1)WRITE(LUB,9506)
      IF(JALG.EQ.2)WRITE(LUB,9507)
      WRITE(LUB,9508)
      WRITE(LUB,9906)NAME
      WRITE(LUB,9900)
      WRITE(LUB,9910)NN
      IF(JLABS.NE.0)WRITE(LUB,8070)
      IF(JLABS.EQ.0)WRITE(LUB,8075)
      IF(JDYSS.NE.0)WRITE(LUB,8080)
      IF(JDYSS.EQ.0)WRITE(LUB,8085)
      IF(LARGE.NE.0)WRITE(LUB,8090)
      IF(LARGE.EQ.0)WRITE(LUB,8095)
      IF(LGRAP.NE.0)WRITE(LUB,8100)
      IF(LGRAP.EQ.0)WRITE(LUB,8105)
      IF(JDYSS.EQ.1)GO TO 880
      IF(JPPT.GT.1)GO TO 852
      WRITE(LUB,8118)
      GO TO 865
  852 WRITE(LUB,8115)JPPT
      IF(JPP.GT.1)GO TO 854
      WRITE(LUB,8119)(JLAB(K,1),K=1,10),JPLACE(1)
      GO TO 865
  854 WRITE(LUB,8116)JPP
      WRITE(LUB,8114)
      DO 860 J=1,JPP
      WRITE(LUB,8117)(JLAB(K,J),K=1,10),JPLACE(J)
  860 CONTINUE
  865 IF(NSTAN.EQ.0)WRITE(LUB,8125)
      IF(NSTAN.EQ.1)WRITE(LUB,8120)
      IF(NDYST.EQ.1)WRITE(LUB,8130)
      IF(NDYST.EQ.2)WRITE(LUB,8135)
      IF(CDATA.EQ.'N')WRITE(LUB,8145)
      IF(CDATA.EQ.'N')GO TO 870
      WRITE(LUB,8140)
      IF(CMDT.EQ.'Y')WRITE(LUB,8142)
      IF(CMDT.EQ.'Y')WRITE(LUB,*)VVAL
  870 IF (CYNFF.EQ.'Y') WRITE(LUB,8160)
      IF (CYNFF.EQ.'N') WRITE(LUB,8165) JFMT
      GO TO 890
  880 IF (CYNFF.EQ.'Y') WRITE(LUB,8170)
      IF (CYNFF.EQ.'N') WRITE(LUB,8175) JFMT
  890 IF (FNAMEB.EQ.'CON') PAUSE ' '
      IF(FNAMEB.NE.'CON')WRITE(LUB,*)
      IF (YNSAVE.EQ.'Y') WRITE(LUB,8038) FNAMEC
      IF (FNAMEA.NE.'CON') WRITE(LUB,8039) FNAMEA
CC
CC   INPUT OF DATA
CC
  900 IF (FNAMEA.EQ.'CON') WRITE(*,8355)
      IF(JDYSS.EQ.1)GO TO 940
      DO 930 L=1,NN
      IF (FNAMEA.NE.'CON')GO TO 910
      WRITE(*,8359)JPPT,LAB(1,L),LAB(2,L),LAB(3,L)
  910 IF (CYNFF.EQ.'N') READ(LUA,JFMT)(HULP(J),J=1,JPPT)
      IF (CYNFF.EQ.'Y') READ(LUA,*)(HULP(J),J=1,JPPT)
      DO 920 J=1,JPP
      JH=JPLACE(J)
      X(L,J)=HULP(JH)
  920 CONTINUE
      IF (YNSAVE.EQ.'N')GO TO 930
      IF (CYNFF.EQ.'N') WRITE(LUC,JFMT)(HULP(J),J=1,JPPT)
      IF (CYNFF.EQ.'Y') WRITE(LUC,*)(HULP(J),J=1,JPPT)
  930 CONTINUE
      IF (YNSAVE.EQ.'Y') CLOSE(LUC,STATUS='KEEP')
      IF (YNSAVE.EQ.'Y') WRITE(*,8038) FNAMEC
      RETURN
  940 DYS(1)=0.0
      IF(FNAMEA.EQ.'CON')WRITE(*,8363)
      DO 990 L=2,NN
      LSUBT=L-1
      IF (FNAMEA.NE.'CON')GO TO 950
      IF (L.EQ.2) WRITE(*,8361) LAB(1,2),LAB(2,2),LAB(3,2),
     F LAB(1,1),LAB(2,1),LAB(3,1)
      IF (L.NE.2) WRITE(*,8362)LSUBT,LAB(1,L),LAB(2,L),LAB(3,L)
  950 IF (CYNFF.EQ.'Y') READ(LUA,*)(DVEC(J),J=1,LSUBT)
      IF (CYNFF.EQ.'N') READ(LUA,JFMT)(DVEC(J),J=1,LSUBT)
      DO 980 J=1,LSUBT
      IF(DVEC(J).GE.0.)GO TO 970
      IF(FNAMEA.EQ.'CON')GO TO 960
      WRITE(*,8365)L,J
      STOP
  960 WRITE(*,8370)LAB(1,L),LAB(2,L),LAB(3,L),LAB(1,J),LAB(2,J),
     F LAB(3,J),LAB(1,L),LAB(2,L),LAB(3,L)
      GO TO 950
  970 NLJ=MEET(L,J)
      DYS(NLJ)=DVEC(J)
  980 CONTINUE
      IF (YNSAVE.EQ.'N')GO TO 990
      IF (CYNFF.EQ.'Y') WRITE(LUC,*)(DVEC(J),J=1,LSUBT)
      IF (CYNFF.EQ.'N') WRITE(LUC,JFMT)(DVEC(J),J=1,LSUBT)
  990 CONTINUE
      IF (YNSAVE.EQ.'Y') CLOSE(LUC,STATUS='KEEP')
      IF (YNSAVE.EQ.'Y') WRITE(*,8038) FNAMEC
      RETURN
 8030  FORMAT(/1X,' ARE ALL THESE OPTIONS OK? YES OR NO: '$)
 8034  FORMAT(1X,' THE DATA WILL BE READ FROM THE KEYBOARD')
 8038  FORMAT(1X,' THE DATA WILL BE SAVED IN THE FILE: ',A30)
 8039  FORMAT(1X,' YOUR DATA RESIDE IN THE FILE: ',A30/)
 8040  FORMAT(1X,' YOUR OUTPUT WILL BE WRITTEN IN: ',A30)
 8070 FORMAT(1X,' LABELS OF OBJECTS ARE READ')
 8075 FORMAT(1X,' LABELS OF OBJECTS ARE NOT READ')
 8080 FORMAT(1X,' INPUT OF DISSIMILARITIES')
 8085 FORMAT(1X,' INPUT OF MEASUREMENTS')
 8090 FORMAT(1X,' LARGE OUTPUT IS WANTED')
 8095 FORMAT(1X,' SMALL OUTPUT')
 8100 FORMAT(1X,' GRAPHICAL OUTPUT IS WANTED (BANNER)')
 8105 FORMAT(1X,' NO GRAPHICAL OUTPUT IS WANTED')
 8114 FORMAT('  THESE VARIABLES ARE :')
 8115 FORMAT(/1X,' THERE ARE ',I4,' VARIABLES IN THE DATA SET,')
 8116 FORMAT(1X,'  AND 'I4,' OF THEM WILL BE USED IN THE ANALYSIS')
 8117 FORMAT(10X,10A1,'   (POSITION :',I3,')')
 8118 FORMAT(/1X,' THERE IS ONE VARIABLE IN THE DATA SET')
 8119 FORMAT(1X,'  AND ONLY VARIABLE ',10A1,' WILL BE USED IN THE'
     F ' ANALYSIS    (POSITION :',I3,')')
 8120 FORMAT(1X,' THE MEASUREMENTS WILL BE STANDARDIZED')
 8125 FORMAT(1X,' THE MEASUREMENTS WILL NOT BE STANDARDIZED')
 8130 FORMAT(1X,' EUCLIDEAN DISTANCE IS USED')
 8135 FORMAT(1X,' MANHATTAN DISTANCE IS USED')
 8140 FORMAT(1X,' MISSING VALUES CAN OCCUR')
 8142 FORMAT(1X,' THE UNIQUE VALUE WHICH REPRESENTS MISSING'
     F' MEASUREMENTS IS :'/6X$)
 8145 FORMAT(1X,' THERE ARE NO MISSING VALUES')
 8160 FORMAT(1X,' THE MEASUREMENTS WILL BE READ IN FREE FORMAT')
 8165 FORMAT(1X,' THE INPUT FORMAT FOR THE MEASUREMENTS IS'/2X,A60)
 8170 FORMAT(1X,' THE DISSIMILARITIES WILL BE READ IN FREE FORMAT')
 8175 FORMAT('  THE INPUT FORMAT FOR THE DISSIMILARITIES IS'/2X,A60)
 8355 FORMAT(//1X,'PLEASE ENTER YOUR DATA FOR EACH OBJECT'//)
 8359 FORMAT(1X,' THE',I3,' MEASUREMENTS FOR OBJECT ',3A1,' : '/)
 8360 FORMAT(1X,'THE',I3,' MEASUREMENTS FOR OBJECT ',3A1,' : '/)
 8361 FORMAT(1X,' DISSIMILARITY BETWEEN OBJECTS ',3A1,
     F' AND ',3A1,' : '/)
 8362 FORMAT(1X,' THE ',I4,' DISSIMILARITIES FOR OBJECT ',3A1,
     F'   : '/)
 8363 FORMAT(1X,' FOR OBJECT J, ENTER DISSIMILARITIES TO OBJECTS',
     F' 1,2,... ,(J-1) '//)
 8365 FORMAT(/1X,'THE DISSIMILARITY BETWEEN OBJECTS',I5,' AND ',I5,
     F' IS NEGATIVE,'/' UNFORTUNATELY THE PROGRAM MUST BE STOPPED.')
 8370 FORMAT(/' THE DISSIMILARITY BETWEEN OBJECTS ',3A1,' AND ',3A1,
     F' IS NEGATIVE.'/1X,'PLEASE ENTER THE DISSIMILARITIES FOR',
     F' OBJECT ',3A1,' ONCE AGAIN :'/)
 8500 FORMAT(A1)
 8510 FORMAT(10A1)
 8520 FORMAT(BNI4,6X,10A1)
 8530 FORMAT(A60)
 8540 FORMAT(3A1)
 8550 FORMAT(A30)
 9000 FORMAT(///////////////26X,29('*')/26X,'*',27X,'*'/26X,'*  HI',
     F'ERARCHICAL CLUSTERING  *'/26X,'*',27X,'*'/26X,29('*')////)
 9010 FORMAT(/1X,'DO YOU WANT AGGLOMERATIVE NESTING (AGNES)'
     F /1X,'OR DIVISIVE ANALYSIS (DIANA)?'/1X,'PLEASE'
     F ' ENTER YOUR CHOICE (A OR D): '$)
 9500 FORMAT(///////////////27X,27('*')/27X,'*',25X,'*'/27X,'*  AG',
     F'GLOMERATIVE NESTING  *'/27X,'*',25X,'*'/27X,27('*')//)
 9501 FORMAT(///////////////29X,23('*')/29X,'*',21X,'*'/29X,'*  DI',
     F'VISIVE ANALYSIS  *'/29X,'*',21X,'*'/29X,23('*')//)
 9505 FORMAT(/' Copyright (C) Leonard Kaufman and Peter'
     F ' Rousseeuw 1990. All rights reserved.'//)
 9506 FORMAT(/6X,'This agglomerative hierarchical clustering'
     F' algorithm is based on'/6X,'the group average method of'
     F' Sokal and Michener.')
 9507 FORMAT(/6X,'This divisive hierarchical clustering'
     F ' algorithm uses the method of'/6X,'McNaughton-Smith,'
     F ' Williams, Dale, and Mockett.')
 9508 FORMAT(6X,'More information is given in:'
     F //6X,'L. Kaufman and P.J. Rousseeuw (1990),'
     F /6X,'Finding Groups in Data: An Introduction to'
     F ' Cluster Analysis,'
     F /6X,'Wiley, New York.'//)
 9510 FORMAT(/1X,'DO YOU WANT TO ENTER MEASUREMENTS? (PLEASE'
     F' ANSWER M)'/1X,'OR DO YOU PREFER TO GIVE'
     F' DISSIMILARITIES? (THEN ANSWER D): '$)
 9520 FORMAT(1X,'NOT ALLOWED! PLEASE ENTER YOUR CHOICE AGAIN: '$)
 9525 FORMAT(//1X,'THE PRESENT VERSION OF THE PROGRAM CAN HANDLE'
     F ' UP TO',I6,' OBJECTS.'/1X,'(IF MORE ARE TO BE CLUSTERED,'
     F ' THE ARRAYS INSIDE THE PROGRAM MUST BE ADAPTED)')
 9530 FORMAT(/1X,'HOW MANY OBJECTS ARE TO BE CLUSTERED? '/1X,
     F37(1H-)/1X,'PLEASE GIVE A NUMBER BETWEEN 3 AND ',I6,' : '$)
 9540 FORMAT(/'  AT LEAST 3 OBJECTS ARE NEEDED FOR CLUSTER ANALYSIS.'
     F','/1X,' PLEASE FORESEE MORE OBJECTS.')
 9620 FORMAT(//1X,'THE PRESENT VERSION OF THE PROGRAM ALLOWS TO'
     F ' ENTER UP TO',I5,' VARIABLES,'/1X,'OF WHICH AT MOST',I5,
     F ' CAN BE USED IN THE ACTUAL COMPUTATIONS.'/1X,'(IF MORE ARE'
     F ' NEEDED, THE ARRAYS INSIDE THE PROGRAM MUST BE ADAPTED)')
 9630 FORMAT(/1X,'WHAT IS THE TOTAL NUMBER OF VARIABLES IN YOUR'
     F' DATA SET ?'/1X,56(1H-)/
     F' PLEASE GIVE A NUMBER BETWEEN 1 AND ',I6,' : '$)
 9640 FORMAT(/38H HOW MANY VARIABLES DO YOU WANT TO USE,
     F' IN THE ANALYSIS?'/1X,54('-')/1X,' (AT MOST ',I4,' ) : '$)
 9650 FORMAT(//1X,'VARIABLE TO BE USED       ',
     F' LABEL (AT MOST 10 CHARACTERS)'/
     F 1X,17(1H-),4(1H),6(1H-),10(1H),19(1H-))
 9660 FORMAT(1X,'NUMBER    :      ',I4,6X$)
 9670 FORMAT(//1X,'VARIABLE TO BE USED        :   POSITION',
     F '   LABEL (AT MOST 10 CHARACTERS)'/
     F 1X,32('-'),4(1H),6('-'),10(1H),19('-'))
 9680 FORMAT(1X,'NUMBER  ',I4,15X,':    '$)
 9690 FORMAT(/' THIS POSITION HAS ALREADY BEEN CHOSEN FOR ANOTHER',
     F' VARIABLE.'/1X,'ENTER THE RIGHT POSITION PLEASE: ')
 9700 FORMAT(/' DO YOU WANT THE MEASUREMENTS TO BE STANDARDIZED?'
     F ' (YES OR NO)......:'$)
 9710 FORMAT(/1X,'DO YOU WANT TO USE EUCLIDEAN DISTANCE? (PLEASE'
     F' ANSWER E)'/1X,'OR DO YOU PREFER MANHATTAN DISTANCE?'
     F' (THEN ANSWER M) ..............: '$)
 9720 FORMAT(/1X,'PLEASE ENTER A TITLE FOR THE OUTPUT (AT MOST 60'
     F ' CHARACTERS)'/1X,59(1H-)/1X$)
 9730 FORMAT(/1X,'DO YOU WANT LARGE OUTPUT? (PLEASE ANSWER YES)'/
     F' OR IS SMALL OUTPUT SUFFICIENT? (THEN ANSWER NO)')
 9732 FORMAT(' (IN THE LATTER CASE NO STANDARDIZED MEASUREMENTS OR'
     F/1X,' DISSIMILARITIES ARE GIVEN)',1X,40('.'),' : '$)
 9734 FORMAT(1X,'(IN THE LATTER CASE NO DISSIMILARITIES ARE GIVEN)'
     F,1X,18('.'),' : '$)
 9740 FORMAT(/1X,'DO YOU WANT GRAPHICAL OUTPUT (BANNER)?'
     F' PLEASE ANSWER YES OR NO ....: '$)
 9750 FORMAT(/1X,'DO YOU WANT TO ENTER LABELS OF OBJECTS?'
     F' PLEASE ANSWER YES OR NO ....: '$)
 9760 FORMAT(/1X,'EACH LABEL MAY CONSIST OF AT MOST 3 CHARACTERS'/
     F/1X,'   OBJECT             LABEL'/
     F 1X,12(1H-),4(1H),6(1H-),3(1H),5(1H-))
 9770 FORMAT(1X,'NUMBER  ',4X,I4,'  :   '$)
 9780 FORMAT(/' DO YOU WANT TO READ THE DATA IN FREE FORMAT ?'/1X,
     F 45(1H-)/' THIS MEANS THAT YOU ONLY HAVE TO INSERT BLANK(S)',
     F 17H BETWEEN NUMBERS./31H (NOTE: WE ADVISE USERS WITHOUT,
     F 45H KNOWLEDGE OF FORTRAN FORMATS TO ANSWER YES.)/
     F ' MAKE YOUR CHOICE (YES/NO): '$)
 9790 FORMAT(/1X,'YOUR DESIRED FORTRAN FORMAT IS:'/
     F1X'(BETWEEN BRACKETS AND',
     F ' AT MOST 60 CHARACTERS, e.g. (2F3.0,F1.0) )')
 9800 FORMAT(/1X,'PLEASE GIVE THE NAME OF THE FILE CONTAINING',
     F' THE DATA (e.g. TYPE A:EXAMPLE.DAT)',/1X,'OR TYPE',
     F'  KEY  IF YOU PREFER TO ENTER THE DATA BY KEYBOARD.'/
     F1X,'WHAT DO YOU CHOOSE? '$)
 9810 FORMAT(/1X,'DO YOU WANT TO SAVE YOUR DATA IN A FILE?'/
     F 1X,'PLEASE ANSWER YES OR NO: ',$)
 9820 FORMAT(/1X,'IN WHICH FILE DO YOU WANT TO SAVE YOUR DATA?'/
     1 ' (WARNING: IF THERE ALREADY EXISTS A FILE WITH THE SAME',
     1 ' NAME'/12X,'THEN THE OLD FILE WILL BE OVERWRITTEN.)'/
     1 ' TYPE e.g.  B:SAVE.DAT .....................: '$)
 9830 FORMAT(/1X,'WHERE DO YOU WANT YOUR OUTPUT?'/1X,30('-')/
     1 '    TYPE  CON  IF YOU WANT IT ON THE SCREEN'/
     1 ' OR TYPE  PRN  IF YOU WANT IT ON THE PRINTER'/
     1 ' OR TYPE THE NAME OF A FILE (e.g. B:EXAMPLE.OUT)'/
     1 ' (WARNING: IF THERE ALREADY EXISTS A FILE WITH THE SAME',
     1 ' NAME'/12X,'THEN THE OLD FILE WILL BE OVERWRITTEN.)'/
     1 ' WHAT DO YOU CHOOSE? ......................: '$)
 9831 FORMAT(/' FILE NAME IS INCORRECT, PLEASE ENTER ANOTHER')
 9832 FORMAT(/' THIS FILE WAS NOT FOUND, PLEASE ENTER ANOTHER ONE')
 9834 FORMAT(/' FORTRAN ERROR CODE:  ',I8)
 9840 FORMAT(/1X,'CAN MISSING DATA OCCUR IN THE MEASUREMENTS?'
     F/1X,'PLEASE ANSWER YES OR NO: '$)
 9850 FORMAT(/' IS THERE A UNIQUE VALUE WHICH IS TO BE INTERPRETED'/
     F1X,'AS A MISSING MEASUREMENT VALUE FOR ANY VARIABLE? '/
     F1X,'PLEASE ANSWER YES OR NO: '$)
 9860 FORMAT(/' PLEASE ENTER THIS VALUE NOW: '$)
 9870 FORMAT(/' SHOULD MISSING VALUES BE FORESEEN FOR VARIABLE ',
     F 10A1,' ?'/' PLEASE ANSWER YES OR NO: '$)
 9880 FORMAT(' ENTER THE VALUE OF THIS VARIABLE WHICH HAS TO BE'
     F' INTERPRETED AS'/' THE MISSING VALUE CODE: '$)
 9890 FORMAT(//////////)
 9900 FORMAT(/' DATA SPECIFICATIONS AND CHOSEN OPTIONS'/1X,38('-'))
 9905 FORMAT(1X,' TITLE: ',A60)
 9906 FORMAT(1X,'TITLE: ',A60)
 9910 FORMAT(1X,' THERE ARE ',I4,' OBJECTS')
      RETURN
      END
